{
  This file was automatically generated on 2020-05-19.

  Delphi/Lazarus Bindings Version 2.1.28

  If you have a bugfix for this file and want to commit it,
  please fix the bug in the generator. You can find a link
  to the generators git on tinkerforge.com
}

unit BrickletCO2V2;

{$ifdef FPC}{$mode OBJFPC}{$H+}{$endif}

interface

uses
  Device, IPConnection, LEConverter, Math, SyncObjs;

const
  BRICKLET_CO2_V2_DEVICE_IDENTIFIER = 2147;
  BRICKLET_CO2_V2_DEVICE_DISPLAY_NAME = 'CO2 Bricklet 2.0';

  BRICKLET_CO2_V2_FUNCTION_GET_ALL_VALUES = 1;
  BRICKLET_CO2_V2_FUNCTION_SET_AIR_PRESSURE = 2;
  BRICKLET_CO2_V2_FUNCTION_GET_AIR_PRESSURE = 3;
  BRICKLET_CO2_V2_FUNCTION_SET_TEMPERATURE_OFFSET = 4;
  BRICKLET_CO2_V2_FUNCTION_GET_TEMPERATURE_OFFSET = 5;
  BRICKLET_CO2_V2_FUNCTION_SET_ALL_VALUES_CALLBACK_CONFIGURATION = 6;
  BRICKLET_CO2_V2_FUNCTION_GET_ALL_VALUES_CALLBACK_CONFIGURATION = 7;
  BRICKLET_CO2_V2_FUNCTION_GET_CO2_CONCENTRATION = 9;
  BRICKLET_CO2_V2_FUNCTION_SET_CO2_CONCENTRATION_CALLBACK_CONFIGURATION = 10;
  BRICKLET_CO2_V2_FUNCTION_GET_CO2_CONCENTRATION_CALLBACK_CONFIGURATION = 11;
  BRICKLET_CO2_V2_FUNCTION_GET_TEMPERATURE = 13;
  BRICKLET_CO2_V2_FUNCTION_SET_TEMPERATURE_CALLBACK_CONFIGURATION = 14;
  BRICKLET_CO2_V2_FUNCTION_GET_TEMPERATURE_CALLBACK_CONFIGURATION = 15;
  BRICKLET_CO2_V2_FUNCTION_GET_HUMIDITY = 17;
  BRICKLET_CO2_V2_FUNCTION_SET_HUMIDITY_CALLBACK_CONFIGURATION = 18;
  BRICKLET_CO2_V2_FUNCTION_GET_HUMIDITY_CALLBACK_CONFIGURATION = 19;
  BRICKLET_CO2_V2_FUNCTION_GET_SPITFP_ERROR_COUNT = 234;
  BRICKLET_CO2_V2_FUNCTION_SET_BOOTLOADER_MODE = 235;
  BRICKLET_CO2_V2_FUNCTION_GET_BOOTLOADER_MODE = 236;
  BRICKLET_CO2_V2_FUNCTION_SET_WRITE_FIRMWARE_POINTER = 237;
  BRICKLET_CO2_V2_FUNCTION_WRITE_FIRMWARE = 238;
  BRICKLET_CO2_V2_FUNCTION_SET_STATUS_LED_CONFIG = 239;
  BRICKLET_CO2_V2_FUNCTION_GET_STATUS_LED_CONFIG = 240;
  BRICKLET_CO2_V2_FUNCTION_GET_CHIP_TEMPERATURE = 242;
  BRICKLET_CO2_V2_FUNCTION_RESET = 243;
  BRICKLET_CO2_V2_FUNCTION_WRITE_UID = 248;
  BRICKLET_CO2_V2_FUNCTION_READ_UID = 249;
  BRICKLET_CO2_V2_FUNCTION_GET_IDENTITY = 255;

  BRICKLET_CO2_V2_CALLBACK_ALL_VALUES = 8;
  BRICKLET_CO2_V2_CALLBACK_CO2_CONCENTRATION = 12;
  BRICKLET_CO2_V2_CALLBACK_TEMPERATURE = 16;
  BRICKLET_CO2_V2_CALLBACK_HUMIDITY = 20;

  BRICKLET_CO2_V2_THRESHOLD_OPTION_OFF = 'x';
  BRICKLET_CO2_V2_THRESHOLD_OPTION_OUTSIDE = 'o';
  BRICKLET_CO2_V2_THRESHOLD_OPTION_INSIDE = 'i';
  BRICKLET_CO2_V2_THRESHOLD_OPTION_SMALLER = '<';
  BRICKLET_CO2_V2_THRESHOLD_OPTION_GREATER = '>';
  BRICKLET_CO2_V2_BOOTLOADER_MODE_BOOTLOADER = 0;
  BRICKLET_CO2_V2_BOOTLOADER_MODE_FIRMWARE = 1;
  BRICKLET_CO2_V2_BOOTLOADER_MODE_BOOTLOADER_WAIT_FOR_REBOOT = 2;
  BRICKLET_CO2_V2_BOOTLOADER_MODE_FIRMWARE_WAIT_FOR_REBOOT = 3;
  BRICKLET_CO2_V2_BOOTLOADER_MODE_FIRMWARE_WAIT_FOR_ERASE_AND_REBOOT = 4;
  BRICKLET_CO2_V2_BOOTLOADER_STATUS_OK = 0;
  BRICKLET_CO2_V2_BOOTLOADER_STATUS_INVALID_MODE = 1;
  BRICKLET_CO2_V2_BOOTLOADER_STATUS_NO_CHANGE = 2;
  BRICKLET_CO2_V2_BOOTLOADER_STATUS_ENTRY_FUNCTION_NOT_PRESENT = 3;
  BRICKLET_CO2_V2_BOOTLOADER_STATUS_DEVICE_IDENTIFIER_INCORRECT = 4;
  BRICKLET_CO2_V2_BOOTLOADER_STATUS_CRC_MISMATCH = 5;
  BRICKLET_CO2_V2_STATUS_LED_CONFIG_OFF = 0;
  BRICKLET_CO2_V2_STATUS_LED_CONFIG_ON = 1;
  BRICKLET_CO2_V2_STATUS_LED_CONFIG_SHOW_HEARTBEAT = 2;
  BRICKLET_CO2_V2_STATUS_LED_CONFIG_SHOW_STATUS = 3;

type
  TArray0To2OfUInt8 = array [0..2] of byte;
  TArray0To63OfUInt8 = array [0..63] of byte;

  TBrickletCO2V2 = class;
  TBrickletCO2V2NotifyAllValues = procedure(sender: TBrickletCO2V2; const co2Concentration: word; const temperature: smallint; const humidity: word) of object;
  TBrickletCO2V2NotifyCO2Concentration = procedure(sender: TBrickletCO2V2; const co2Concentration: word) of object;
  TBrickletCO2V2NotifyTemperature = procedure(sender: TBrickletCO2V2; const temperature: smallint) of object;
  TBrickletCO2V2NotifyHumidity = procedure(sender: TBrickletCO2V2; const humidity: word) of object;

  /// <summary>
  ///  Measures CO2 concentration, temperature and humidity
  /// </summary>
  TBrickletCO2V2 = class(TDevice)
  private
    allValuesCallback: TBrickletCO2V2NotifyAllValues;
    co2ConcentrationCallback: TBrickletCO2V2NotifyCO2Concentration;
    temperatureCallback: TBrickletCO2V2NotifyTemperature;
    humidityCallback: TBrickletCO2V2NotifyHumidity;
  protected
    procedure CallbackWrapperAllValues(const packet: TByteArray); virtual;
    procedure CallbackWrapperCO2Concentration(const packet: TByteArray); virtual;
    procedure CallbackWrapperTemperature(const packet: TByteArray); virtual;
    procedure CallbackWrapperHumidity(const packet: TByteArray); virtual;
  public
    /// <summary>
    ///  Creates an object with the unique device ID <c>uid</c>. This object can
    ///  then be added to the IP connection.
    /// </summary>
    constructor Create(const uid: string; ipcon_: TIPConnection);

    /// <summary>
    ///  Returns all values measured by the CO2 Bricklet 2.0.
    ///  
    ///  If you want to get the values periodically, it is recommended to use the
    ///  <see cref="BrickletCO2V2.TBrickletCO2V2.OnAllValues"/> callback. You can set the callback configuration
    ///  with <see cref="BrickletCO2V2.TBrickletCO2V2.SetAllValuesCallbackConfiguration"/>.
    ///  
    ///  <note>
    ///   The sensor is able to messure up to 120 °C. However it is only specified up to 70 °C.
    ///   Exposing the Bricklet to higher temperatures might result in permanent damage.
    ///  </note>
    /// </summary>
    procedure GetAllValues(out co2Concentration: word; out temperature: smallint; out humidity: word); virtual;

    /// <summary>
    ///  The CO2 concentration depends (among other things) on the ambient air pressure.
    ///  
    ///  To increase the accuracy of the CO2 Bricklet 2.0 you can set the current air pressure.
    ///  You use the :ref:`Barometer Bricklet 2.0 &lt;barometer_v2_bricklet&gt;` or the
    ///  :ref:`Air Quality Bricklet &lt;air_quality_bricklet&gt;` to get the current air pressure.
    ///  
    ///  By default air pressure compensation is disabled. Once you set a value it
    ///  will be used for compensation. You can turn the compensation off again by
    ///  setting the value to 0.
    ///  
    ///  It is sufficient to update the value every few minutes.
    /// </summary>
    procedure SetAirPressure(const airPressure: word); virtual;

    /// <summary>
    ///  Returns the ambient air pressure as set by <see cref="BrickletCO2V2.TBrickletCO2V2.SetAirPressure"/>.
    /// </summary>
    function GetAirPressure: word; virtual;

    /// <summary>
    ///  Sets a temperature offset. A offset of 10 will decrease
    ///  the measured temperature by 0.1 °C.
    ///  
    ///  If you install this Bricklet into an enclosure and you want to measure the ambient
    ///  temperature, you may have to decrease the measured temperature by some value to
    ///  compensate for the error because of the heating inside of the enclosure.
    ///  
    ///  We recommend that you leave the parts in the enclosure running for at least
    ///  24 hours such that a temperature equilibrium can be reached. After that you can measure
    ///  the temperature directly outside of enclosure and set the difference as offset.
    ///  
    ///  This temperature offset is used to calculate the relative humidity and
    ///  CO2 concentration. In case the Bricklet is installed in an enclosure, we
    ///  recommend to measure and set the temperature offset to improve the accuracy of
    ///  the measurements.
    ///  
    ///  It is sufficient to set the temperature offset once. The offset is saved in
    ///  non-volatile memory and is applied again after a power loss.
    /// </summary>
    procedure SetTemperatureOffset(const offset: word); virtual;

    /// <summary>
    ///  Returns the temperature offset as set by
    ///  <see cref="BrickletCO2V2.TBrickletCO2V2.SetTemperatureOffset"/>.
    /// </summary>
    function GetTemperatureOffset: word; virtual;

    /// <summary>
    ///  The period is the period with which the <see cref="BrickletCO2V2.TBrickletCO2V2.OnAllValues"/>
    ///  callback is triggered periodically. A value of 0 turns the callback off.
    ///  
    ///  If the `value has to change`-parameter is set to true, the callback is only
    ///  triggered after at least one of the values has changed. If the values didn't
    ///  change within the period, the callback is triggered immediately on change.
    ///  
    ///  If it is set to false, the callback is continuously triggered with the period,
    ///  independent of the value.
    /// </summary>
    procedure SetAllValuesCallbackConfiguration(const period: longword; const valueHasToChange: boolean); virtual;

    /// <summary>
    ///  Returns the callback configuration as set by
    ///  <see cref="BrickletCO2V2.TBrickletCO2V2.SetAllValuesCallbackConfiguration"/>.
    /// </summary>
    procedure GetAllValuesCallbackConfiguration(out period: longword; out valueHasToChange: boolean); virtual;

    /// <summary>
    ///  Returns CO2 concentration.
    ///  
    ///  
    ///  If you want to get the value periodically, it is recommended to use the
    ///  <see cref="BrickletCO2V2.TBrickletCO2V2.OnCO2Concentration"/> callback. You can set the callback configuration
    ///  with <see cref="BrickletCO2V2.TBrickletCO2V2.SetCO2ConcentrationCallbackConfiguration"/>.
    /// </summary>
    function GetCO2Concentration: word; virtual;

    /// <summary>
    ///  The period is the period with which the <see cref="BrickletCO2V2.TBrickletCO2V2.OnCO2Concentration"/> callback is triggered
    ///  periodically. A value of 0 turns the callback off.
    ///  
    ///  If the `value has to change`-parameter is set to true, the callback is only
    ///  triggered after the value has changed. If the value didn't change
    ///  within the period, the callback is triggered immediately on change.
    ///  
    ///  If it is set to false, the callback is continuously triggered with the period,
    ///  independent of the value.
    ///  
    ///  It is furthermore possible to constrain the callback with thresholds.
    ///  
    ///  The `option`-parameter together with min/max sets a threshold for the <see cref="BrickletCO2V2.TBrickletCO2V2.OnCO2Concentration"/> callback.
    ///  
    ///  The following options are possible:
    ///  
    ///  <code>
    ///   "Option", "Description"
    ///  
    ///   "'x'",    "Threshold is turned off"
    ///   "'o'",    "Threshold is triggered when the value is *outside* the min and max values"
    ///   "'i'",    "Threshold is triggered when the value is *inside* or equal to the min and max values"
    ///   "'&lt;'",    "Threshold is triggered when the value is smaller than the min value (max is ignored)"
    ///   "'&gt;'",    "Threshold is triggered when the value is greater than the min value (max is ignored)"
    ///  </code>
    ///  
    ///  If the option is set to 'x' (threshold turned off) the callback is triggered with the fixed period.
    /// </summary>
    procedure SetCO2ConcentrationCallbackConfiguration(const period: longword; const valueHasToChange: boolean; const option: char; const min: word; const max: word); virtual;

    /// <summary>
    ///  Returns the callback configuration as set by <see cref="BrickletCO2V2.TBrickletCO2V2.SetCO2ConcentrationCallbackConfiguration"/>.
    /// </summary>
    procedure GetCO2ConcentrationCallbackConfiguration(out period: longword; out valueHasToChange: boolean; out option: char; out min: word; out max: word); virtual;

    /// <summary>
    ///  Returns temperature.
    ///  
    ///  <note>
    ///   The sensor is able to messure up to 120 °C. However it is only specified up to 70 °C.
    ///   Exposing the Bricklet to higher temperatures might result in permanent damage.
    ///  </note>
    ///  
    ///  
    ///  If you want to get the value periodically, it is recommended to use the
    ///  <see cref="BrickletCO2V2.TBrickletCO2V2.OnTemperature"/> callback. You can set the callback configuration
    ///  with <see cref="BrickletCO2V2.TBrickletCO2V2.SetTemperatureCallbackConfiguration"/>.
    /// </summary>
    function GetTemperature: smallint; virtual;

    /// <summary>
    ///  The period is the period with which the <see cref="BrickletCO2V2.TBrickletCO2V2.OnTemperature"/> callback is triggered
    ///  periodically. A value of 0 turns the callback off.
    ///  
    ///  If the `value has to change`-parameter is set to true, the callback is only
    ///  triggered after the value has changed. If the value didn't change
    ///  within the period, the callback is triggered immediately on change.
    ///  
    ///  If it is set to false, the callback is continuously triggered with the period,
    ///  independent of the value.
    ///  
    ///  It is furthermore possible to constrain the callback with thresholds.
    ///  
    ///  The `option`-parameter together with min/max sets a threshold for the <see cref="BrickletCO2V2.TBrickletCO2V2.OnTemperature"/> callback.
    ///  
    ///  The following options are possible:
    ///  
    ///  <code>
    ///   "Option", "Description"
    ///  
    ///   "'x'",    "Threshold is turned off"
    ///   "'o'",    "Threshold is triggered when the value is *outside* the min and max values"
    ///   "'i'",    "Threshold is triggered when the value is *inside* or equal to the min and max values"
    ///   "'&lt;'",    "Threshold is triggered when the value is smaller than the min value (max is ignored)"
    ///   "'&gt;'",    "Threshold is triggered when the value is greater than the min value (max is ignored)"
    ///  </code>
    ///  
    ///  If the option is set to 'x' (threshold turned off) the callback is triggered with the fixed period.
    /// </summary>
    procedure SetTemperatureCallbackConfiguration(const period: longword; const valueHasToChange: boolean; const option: char; const min: smallint; const max: smallint); virtual;

    /// <summary>
    ///  Returns the callback configuration as set by <see cref="BrickletCO2V2.TBrickletCO2V2.SetTemperatureCallbackConfiguration"/>.
    /// </summary>
    procedure GetTemperatureCallbackConfiguration(out period: longword; out valueHasToChange: boolean; out option: char; out min: smallint; out max: smallint); virtual;

    /// <summary>
    ///  Returns relative humidity.
    ///  
    ///  
    ///  If you want to get the value periodically, it is recommended to use the
    ///  <see cref="BrickletCO2V2.TBrickletCO2V2.OnHumidity"/> callback. You can set the callback configuration
    ///  with <see cref="BrickletCO2V2.TBrickletCO2V2.SetHumidityCallbackConfiguration"/>.
    /// </summary>
    function GetHumidity: word; virtual;

    /// <summary>
    ///  The period is the period with which the <see cref="BrickletCO2V2.TBrickletCO2V2.OnHumidity"/> callback is triggered
    ///  periodically. A value of 0 turns the callback off.
    ///  
    ///  If the `value has to change`-parameter is set to true, the callback is only
    ///  triggered after the value has changed. If the value didn't change
    ///  within the period, the callback is triggered immediately on change.
    ///  
    ///  If it is set to false, the callback is continuously triggered with the period,
    ///  independent of the value.
    ///  
    ///  It is furthermore possible to constrain the callback with thresholds.
    ///  
    ///  The `option`-parameter together with min/max sets a threshold for the <see cref="BrickletCO2V2.TBrickletCO2V2.OnHumidity"/> callback.
    ///  
    ///  The following options are possible:
    ///  
    ///  <code>
    ///   "Option", "Description"
    ///  
    ///   "'x'",    "Threshold is turned off"
    ///   "'o'",    "Threshold is triggered when the value is *outside* the min and max values"
    ///   "'i'",    "Threshold is triggered when the value is *inside* or equal to the min and max values"
    ///   "'&lt;'",    "Threshold is triggered when the value is smaller than the min value (max is ignored)"
    ///   "'&gt;'",    "Threshold is triggered when the value is greater than the min value (max is ignored)"
    ///  </code>
    ///  
    ///  If the option is set to 'x' (threshold turned off) the callback is triggered with the fixed period.
    /// </summary>
    procedure SetHumidityCallbackConfiguration(const period: longword; const valueHasToChange: boolean; const option: char; const min: word; const max: word); virtual;

    /// <summary>
    ///  Returns the callback configuration as set by <see cref="BrickletCO2V2.TBrickletCO2V2.SetHumidityCallbackConfiguration"/>.
    /// </summary>
    procedure GetHumidityCallbackConfiguration(out period: longword; out valueHasToChange: boolean; out option: char; out min: word; out max: word); virtual;

    /// <summary>
    ///  Returns the error count for the communication between Brick and Bricklet.
    ///  
    ///  The errors are divided into
    ///  
    ///  * ACK checksum errors,
    ///  * message checksum errors,
    ///  * framing errors and
    ///  * overflow errors.
    ///  
    ///  The errors counts are for errors that occur on the Bricklet side. All
    ///  Bricks have a similar function that returns the errors on the Brick side.
    /// </summary>
    procedure GetSPITFPErrorCount(out errorCountAckChecksum: longword; out errorCountMessageChecksum: longword; out errorCountFrame: longword; out errorCountOverflow: longword); virtual;

    /// <summary>
    ///  Sets the bootloader mode and returns the status after the requested
    ///  mode change was instigated.
    ///  
    ///  You can change from bootloader mode to firmware mode and vice versa. A change
    ///  from bootloader mode to firmware mode will only take place if the entry function,
    ///  device identifier and CRC are present and correct.
    ///  
    ///  This function is used by Brick Viewer during flashing. It should not be
    ///  necessary to call it in a normal user program.
    /// </summary>
    function SetBootloaderMode(const mode: byte): byte; virtual;

    /// <summary>
    ///  Returns the current bootloader mode, see <see cref="BrickletCO2V2.TBrickletCO2V2.SetBootloaderMode"/>.
    /// </summary>
    function GetBootloaderMode: byte; virtual;

    /// <summary>
    ///  Sets the firmware pointer for <see cref="BrickletCO2V2.TBrickletCO2V2.WriteFirmware"/>. The pointer has
    ///  to be increased by chunks of size 64. The data is written to flash
    ///  every 4 chunks (which equals to one page of size 256).
    ///  
    ///  This function is used by Brick Viewer during flashing. It should not be
    ///  necessary to call it in a normal user program.
    /// </summary>
    procedure SetWriteFirmwarePointer(const pointer: longword); virtual;

    /// <summary>
    ///  Writes 64 Bytes of firmware at the position as written by
    ///  <see cref="BrickletCO2V2.TBrickletCO2V2.SetWriteFirmwarePointer"/> before. The firmware is written
    ///  to flash every 4 chunks.
    ///  
    ///  You can only write firmware in bootloader mode.
    ///  
    ///  This function is used by Brick Viewer during flashing. It should not be
    ///  necessary to call it in a normal user program.
    /// </summary>
    function WriteFirmware(const data: array of byte): byte; virtual;

    /// <summary>
    ///  Sets the status LED configuration. By default the LED shows
    ///  communication traffic between Brick and Bricklet, it flickers once
    ///  for every 10 received data packets.
    ///  
    ///  You can also turn the LED permanently on/off or show a heartbeat.
    ///  
    ///  If the Bricklet is in bootloader mode, the LED is will show heartbeat by default.
    /// </summary>
    procedure SetStatusLEDConfig(const config: byte); virtual;

    /// <summary>
    ///  Returns the configuration as set by <see cref="BrickletCO2V2.TBrickletCO2V2.SetStatusLEDConfig"/>
    /// </summary>
    function GetStatusLEDConfig: byte; virtual;

    /// <summary>
    ///  Returns the temperature as measured inside the microcontroller. The
    ///  value returned is not the ambient temperature!
    ///  
    ///  The temperature is only proportional to the real temperature and it has bad
    ///  accuracy. Practically it is only useful as an indicator for
    ///  temperature changes.
    /// </summary>
    function GetChipTemperature: smallint; virtual;

    /// <summary>
    ///  Calling this function will reset the Bricklet. All configurations
    ///  will be lost.
    ///  
    ///  After a reset you have to create new device objects,
    ///  calling functions on the existing ones will result in
    ///  undefined behavior!
    /// </summary>
    procedure Reset; virtual;

    /// <summary>
    ///  Writes a new UID into flash. If you want to set a new UID
    ///  you have to decode the Base58 encoded UID string into an
    ///  integer first.
    ///  
    ///  We recommend that you use Brick Viewer to change the UID.
    /// </summary>
    procedure WriteUID(const uid: longword); virtual;

    /// <summary>
    ///  Returns the current UID as an integer. Encode as
    ///  Base58 to get the usual string version.
    /// </summary>
    function ReadUID: longword; virtual;

    /// <summary>
    ///  Returns the UID, the UID where the Bricklet is connected to,
    ///  the position, the hardware and firmware version as well as the
    ///  device identifier.
    ///  
    ///  The position can be 'a', 'b', 'c', 'd', 'e', 'f', 'g' or 'h' (Bricklet Port).
    ///  The Raspberry Pi HAT (Zero) Brick is always at position 'i' and the Bricklet
    ///  connected to an :ref:`Isolator Bricklet &lt;isolator_bricklet&gt;` is always as
    ///  position 'z'.
    ///  
    ///  The device identifier numbers can be found :ref:`here &lt;device_identifier&gt;`.
    ///  |device_identifier_constant|
    /// </summary>
    procedure GetIdentity(out uid: string; out connectedUid: string; out position: char; out hardwareVersion: TVersionNumber; out firmwareVersion: TVersionNumber; out deviceIdentifier: word); override;

    /// <summary>
    ///  This callback is triggered periodically according to the configuration set by
    ///  <see cref="BrickletCO2V2.TBrickletCO2V2.SetAllValuesCallbackConfiguration"/>.
    ///  
    ///  The parameters are the same as <see cref="BrickletCO2V2.TBrickletCO2V2.GetAllValues"/>.
    ///  
    ///  <note>
    ///   The sensor is able to messure up to 120 °C. However it is only specified up to 70 °C.
    ///   Exposing the Bricklet to higher temperatures might result in permanent damage.
    ///  </note>
    /// </summary>
    property OnAllValues: TBrickletCO2V2NotifyAllValues read allValuesCallback write allValuesCallback;

    /// <summary>
    ///  This callback is triggered periodically according to the configuration set by
    ///  <see cref="BrickletCO2V2.TBrickletCO2V2.SetCO2ConcentrationCallbackConfiguration"/>.
    ///  
    ///  The parameter is the same as <see cref="BrickletCO2V2.TBrickletCO2V2.GetCO2Concentration"/>.
    /// </summary>
    property OnCO2Concentration: TBrickletCO2V2NotifyCO2Concentration read co2ConcentrationCallback write co2ConcentrationCallback;

    /// <summary>
    ///  This callback is triggered periodically according to the configuration set by
    ///  <see cref="BrickletCO2V2.TBrickletCO2V2.SetTemperatureCallbackConfiguration"/>.
    ///  
    ///  The parameter is the same as <see cref="BrickletCO2V2.TBrickletCO2V2.GetTemperature"/>.
    /// </summary>
    property OnTemperature: TBrickletCO2V2NotifyTemperature read temperatureCallback write temperatureCallback;

    /// <summary>
    ///  This callback is triggered periodically according to the configuration set by
    ///  <see cref="BrickletCO2V2.TBrickletCO2V2.SetHumidityCallbackConfiguration"/>.
    ///  
    ///  The parameter is the same as <see cref="BrickletCO2V2.TBrickletCO2V2.GetHumidity"/>.
    /// </summary>
    property OnHumidity: TBrickletCO2V2NotifyHumidity read humidityCallback write humidityCallback;
  end;

implementation

constructor TBrickletCO2V2.Create(const uid: string; ipcon_: TIPConnection);
begin
  inherited Create(uid, ipcon_, BRICKLET_CO2_V2_DEVICE_IDENTIFIER, BRICKLET_CO2_V2_DEVICE_DISPLAY_NAME);
  apiVersion[0] := 2;
  apiVersion[1] := 0;
  apiVersion[2] := 0;

  responseExpected[BRICKLET_CO2_V2_FUNCTION_GET_ALL_VALUES] := DEVICE_RESPONSE_EXPECTED_ALWAYS_TRUE;
  responseExpected[BRICKLET_CO2_V2_FUNCTION_SET_AIR_PRESSURE] := DEVICE_RESPONSE_EXPECTED_FALSE;
  responseExpected[BRICKLET_CO2_V2_FUNCTION_GET_AIR_PRESSURE] := DEVICE_RESPONSE_EXPECTED_ALWAYS_TRUE;
  responseExpected[BRICKLET_CO2_V2_FUNCTION_SET_TEMPERATURE_OFFSET] := DEVICE_RESPONSE_EXPECTED_FALSE;
  responseExpected[BRICKLET_CO2_V2_FUNCTION_GET_TEMPERATURE_OFFSET] := DEVICE_RESPONSE_EXPECTED_ALWAYS_TRUE;
  responseExpected[BRICKLET_CO2_V2_FUNCTION_SET_ALL_VALUES_CALLBACK_CONFIGURATION] := DEVICE_RESPONSE_EXPECTED_TRUE;
  responseExpected[BRICKLET_CO2_V2_FUNCTION_GET_ALL_VALUES_CALLBACK_CONFIGURATION] := DEVICE_RESPONSE_EXPECTED_ALWAYS_TRUE;
  responseExpected[BRICKLET_CO2_V2_FUNCTION_GET_CO2_CONCENTRATION] := DEVICE_RESPONSE_EXPECTED_ALWAYS_TRUE;
  responseExpected[BRICKLET_CO2_V2_FUNCTION_SET_CO2_CONCENTRATION_CALLBACK_CONFIGURATION] := DEVICE_RESPONSE_EXPECTED_TRUE;
  responseExpected[BRICKLET_CO2_V2_FUNCTION_GET_CO2_CONCENTRATION_CALLBACK_CONFIGURATION] := DEVICE_RESPONSE_EXPECTED_ALWAYS_TRUE;
  responseExpected[BRICKLET_CO2_V2_FUNCTION_GET_TEMPERATURE] := DEVICE_RESPONSE_EXPECTED_ALWAYS_TRUE;
  responseExpected[BRICKLET_CO2_V2_FUNCTION_SET_TEMPERATURE_CALLBACK_CONFIGURATION] := DEVICE_RESPONSE_EXPECTED_TRUE;
  responseExpected[BRICKLET_CO2_V2_FUNCTION_GET_TEMPERATURE_CALLBACK_CONFIGURATION] := DEVICE_RESPONSE_EXPECTED_ALWAYS_TRUE;
  responseExpected[BRICKLET_CO2_V2_FUNCTION_GET_HUMIDITY] := DEVICE_RESPONSE_EXPECTED_ALWAYS_TRUE;
  responseExpected[BRICKLET_CO2_V2_FUNCTION_SET_HUMIDITY_CALLBACK_CONFIGURATION] := DEVICE_RESPONSE_EXPECTED_TRUE;
  responseExpected[BRICKLET_CO2_V2_FUNCTION_GET_HUMIDITY_CALLBACK_CONFIGURATION] := DEVICE_RESPONSE_EXPECTED_ALWAYS_TRUE;
  responseExpected[BRICKLET_CO2_V2_FUNCTION_GET_SPITFP_ERROR_COUNT] := DEVICE_RESPONSE_EXPECTED_ALWAYS_TRUE;
  responseExpected[BRICKLET_CO2_V2_FUNCTION_SET_BOOTLOADER_MODE] := DEVICE_RESPONSE_EXPECTED_ALWAYS_TRUE;
  responseExpected[BRICKLET_CO2_V2_FUNCTION_GET_BOOTLOADER_MODE] := DEVICE_RESPONSE_EXPECTED_ALWAYS_TRUE;
  responseExpected[BRICKLET_CO2_V2_FUNCTION_SET_WRITE_FIRMWARE_POINTER] := DEVICE_RESPONSE_EXPECTED_FALSE;
  responseExpected[BRICKLET_CO2_V2_FUNCTION_WRITE_FIRMWARE] := DEVICE_RESPONSE_EXPECTED_ALWAYS_TRUE;
  responseExpected[BRICKLET_CO2_V2_FUNCTION_SET_STATUS_LED_CONFIG] := DEVICE_RESPONSE_EXPECTED_FALSE;
  responseExpected[BRICKLET_CO2_V2_FUNCTION_GET_STATUS_LED_CONFIG] := DEVICE_RESPONSE_EXPECTED_ALWAYS_TRUE;
  responseExpected[BRICKLET_CO2_V2_FUNCTION_GET_CHIP_TEMPERATURE] := DEVICE_RESPONSE_EXPECTED_ALWAYS_TRUE;
  responseExpected[BRICKLET_CO2_V2_FUNCTION_RESET] := DEVICE_RESPONSE_EXPECTED_FALSE;
  responseExpected[BRICKLET_CO2_V2_FUNCTION_WRITE_UID] := DEVICE_RESPONSE_EXPECTED_FALSE;
  responseExpected[BRICKLET_CO2_V2_FUNCTION_READ_UID] := DEVICE_RESPONSE_EXPECTED_ALWAYS_TRUE;
  responseExpected[BRICKLET_CO2_V2_FUNCTION_GET_IDENTITY] := DEVICE_RESPONSE_EXPECTED_ALWAYS_TRUE;

  callbackWrappers[BRICKLET_CO2_V2_CALLBACK_ALL_VALUES] := {$ifdef FPC}@{$endif}CallbackWrapperAllValues;
  callbackWrappers[BRICKLET_CO2_V2_CALLBACK_CO2_CONCENTRATION] := {$ifdef FPC}@{$endif}CallbackWrapperCO2Concentration;
  callbackWrappers[BRICKLET_CO2_V2_CALLBACK_TEMPERATURE] := {$ifdef FPC}@{$endif}CallbackWrapperTemperature;
  callbackWrappers[BRICKLET_CO2_V2_CALLBACK_HUMIDITY] := {$ifdef FPC}@{$endif}CallbackWrapperHumidity;

  (ipcon as TIPConnection).AddDevice(self);
end;

procedure TBrickletCO2V2.GetAllValues(out co2Concentration: word; out temperature: smallint; out humidity: word);
var request, response: TByteArray;
begin
  CheckValidity;
  request := (ipcon as TIPConnection).CreateRequestPacket(self, BRICKLET_CO2_V2_FUNCTION_GET_ALL_VALUES, 8);
  response := SendRequest(request, 14);
  co2Concentration := LEConvertUInt16From(8, response);
  temperature := LEConvertInt16From(10, response);
  humidity := LEConvertUInt16From(12, response);
end;

procedure TBrickletCO2V2.SetAirPressure(const airPressure: word);
var request: TByteArray;
begin
  CheckValidity;
  request := (ipcon as TIPConnection).CreateRequestPacket(self, BRICKLET_CO2_V2_FUNCTION_SET_AIR_PRESSURE, 10);
  LEConvertUInt16To(airPressure, 8, request);
  SendRequest(request, 0);
end;

function TBrickletCO2V2.GetAirPressure: word;
var request, response: TByteArray;
begin
  CheckValidity;
  request := (ipcon as TIPConnection).CreateRequestPacket(self, BRICKLET_CO2_V2_FUNCTION_GET_AIR_PRESSURE, 8);
  response := SendRequest(request, 10);
  result := LEConvertUInt16From(8, response);
end;

procedure TBrickletCO2V2.SetTemperatureOffset(const offset: word);
var request: TByteArray;
begin
  CheckValidity;
  request := (ipcon as TIPConnection).CreateRequestPacket(self, BRICKLET_CO2_V2_FUNCTION_SET_TEMPERATURE_OFFSET, 10);
  LEConvertUInt16To(offset, 8, request);
  SendRequest(request, 0);
end;

function TBrickletCO2V2.GetTemperatureOffset: word;
var request, response: TByteArray;
begin
  CheckValidity;
  request := (ipcon as TIPConnection).CreateRequestPacket(self, BRICKLET_CO2_V2_FUNCTION_GET_TEMPERATURE_OFFSET, 8);
  response := SendRequest(request, 10);
  result := LEConvertUInt16From(8, response);
end;

procedure TBrickletCO2V2.SetAllValuesCallbackConfiguration(const period: longword; const valueHasToChange: boolean);
var request: TByteArray;
begin
  CheckValidity;
  request := (ipcon as TIPConnection).CreateRequestPacket(self, BRICKLET_CO2_V2_FUNCTION_SET_ALL_VALUES_CALLBACK_CONFIGURATION, 13);
  LEConvertUInt32To(period, 8, request);
  LEConvertBooleanTo(valueHasToChange, 12, request);
  SendRequest(request, 0);
end;

procedure TBrickletCO2V2.GetAllValuesCallbackConfiguration(out period: longword; out valueHasToChange: boolean);
var request, response: TByteArray;
begin
  CheckValidity;
  request := (ipcon as TIPConnection).CreateRequestPacket(self, BRICKLET_CO2_V2_FUNCTION_GET_ALL_VALUES_CALLBACK_CONFIGURATION, 8);
  response := SendRequest(request, 13);
  period := LEConvertUInt32From(8, response);
  valueHasToChange := LEConvertBooleanFrom(12, response);
end;

function TBrickletCO2V2.GetCO2Concentration: word;
var request, response: TByteArray;
begin
  CheckValidity;
  request := (ipcon as TIPConnection).CreateRequestPacket(self, BRICKLET_CO2_V2_FUNCTION_GET_CO2_CONCENTRATION, 8);
  response := SendRequest(request, 10);
  result := LEConvertUInt16From(8, response);
end;

procedure TBrickletCO2V2.SetCO2ConcentrationCallbackConfiguration(const period: longword; const valueHasToChange: boolean; const option: char; const min: word; const max: word);
var request: TByteArray;
begin
  CheckValidity;
  request := (ipcon as TIPConnection).CreateRequestPacket(self, BRICKLET_CO2_V2_FUNCTION_SET_CO2_CONCENTRATION_CALLBACK_CONFIGURATION, 18);
  LEConvertUInt32To(period, 8, request);
  LEConvertBooleanTo(valueHasToChange, 12, request);
  LEConvertCharTo(option, 13, request);
  LEConvertUInt16To(min, 14, request);
  LEConvertUInt16To(max, 16, request);
  SendRequest(request, 0);
end;

procedure TBrickletCO2V2.GetCO2ConcentrationCallbackConfiguration(out period: longword; out valueHasToChange: boolean; out option: char; out min: word; out max: word);
var request, response: TByteArray;
begin
  CheckValidity;
  request := (ipcon as TIPConnection).CreateRequestPacket(self, BRICKLET_CO2_V2_FUNCTION_GET_CO2_CONCENTRATION_CALLBACK_CONFIGURATION, 8);
  response := SendRequest(request, 18);
  period := LEConvertUInt32From(8, response);
  valueHasToChange := LEConvertBooleanFrom(12, response);
  option := LEConvertCharFrom(13, response);
  min := LEConvertUInt16From(14, response);
  max := LEConvertUInt16From(16, response);
end;

function TBrickletCO2V2.GetTemperature: smallint;
var request, response: TByteArray;
begin
  CheckValidity;
  request := (ipcon as TIPConnection).CreateRequestPacket(self, BRICKLET_CO2_V2_FUNCTION_GET_TEMPERATURE, 8);
  response := SendRequest(request, 10);
  result := LEConvertInt16From(8, response);
end;

procedure TBrickletCO2V2.SetTemperatureCallbackConfiguration(const period: longword; const valueHasToChange: boolean; const option: char; const min: smallint; const max: smallint);
var request: TByteArray;
begin
  CheckValidity;
  request := (ipcon as TIPConnection).CreateRequestPacket(self, BRICKLET_CO2_V2_FUNCTION_SET_TEMPERATURE_CALLBACK_CONFIGURATION, 18);
  LEConvertUInt32To(period, 8, request);
  LEConvertBooleanTo(valueHasToChange, 12, request);
  LEConvertCharTo(option, 13, request);
  LEConvertInt16To(min, 14, request);
  LEConvertInt16To(max, 16, request);
  SendRequest(request, 0);
end;

procedure TBrickletCO2V2.GetTemperatureCallbackConfiguration(out period: longword; out valueHasToChange: boolean; out option: char; out min: smallint; out max: smallint);
var request, response: TByteArray;
begin
  CheckValidity;
  request := (ipcon as TIPConnection).CreateRequestPacket(self, BRICKLET_CO2_V2_FUNCTION_GET_TEMPERATURE_CALLBACK_CONFIGURATION, 8);
  response := SendRequest(request, 18);
  period := LEConvertUInt32From(8, response);
  valueHasToChange := LEConvertBooleanFrom(12, response);
  option := LEConvertCharFrom(13, response);
  min := LEConvertInt16From(14, response);
  max := LEConvertInt16From(16, response);
end;

function TBrickletCO2V2.GetHumidity: word;
var request, response: TByteArray;
begin
  CheckValidity;
  request := (ipcon as TIPConnection).CreateRequestPacket(self, BRICKLET_CO2_V2_FUNCTION_GET_HUMIDITY, 8);
  response := SendRequest(request, 10);
  result := LEConvertUInt16From(8, response);
end;

procedure TBrickletCO2V2.SetHumidityCallbackConfiguration(const period: longword; const valueHasToChange: boolean; const option: char; const min: word; const max: word);
var request: TByteArray;
begin
  CheckValidity;
  request := (ipcon as TIPConnection).CreateRequestPacket(self, BRICKLET_CO2_V2_FUNCTION_SET_HUMIDITY_CALLBACK_CONFIGURATION, 18);
  LEConvertUInt32To(period, 8, request);
  LEConvertBooleanTo(valueHasToChange, 12, request);
  LEConvertCharTo(option, 13, request);
  LEConvertUInt16To(min, 14, request);
  LEConvertUInt16To(max, 16, request);
  SendRequest(request, 0);
end;

procedure TBrickletCO2V2.GetHumidityCallbackConfiguration(out period: longword; out valueHasToChange: boolean; out option: char; out min: word; out max: word);
var request, response: TByteArray;
begin
  CheckValidity;
  request := (ipcon as TIPConnection).CreateRequestPacket(self, BRICKLET_CO2_V2_FUNCTION_GET_HUMIDITY_CALLBACK_CONFIGURATION, 8);
  response := SendRequest(request, 18);
  period := LEConvertUInt32From(8, response);
  valueHasToChange := LEConvertBooleanFrom(12, response);
  option := LEConvertCharFrom(13, response);
  min := LEConvertUInt16From(14, response);
  max := LEConvertUInt16From(16, response);
end;

procedure TBrickletCO2V2.GetSPITFPErrorCount(out errorCountAckChecksum: longword; out errorCountMessageChecksum: longword; out errorCountFrame: longword; out errorCountOverflow: longword);
var request, response: TByteArray;
begin
  CheckValidity;
  request := (ipcon as TIPConnection).CreateRequestPacket(self, BRICKLET_CO2_V2_FUNCTION_GET_SPITFP_ERROR_COUNT, 8);
  response := SendRequest(request, 24);
  errorCountAckChecksum := LEConvertUInt32From(8, response);
  errorCountMessageChecksum := LEConvertUInt32From(12, response);
  errorCountFrame := LEConvertUInt32From(16, response);
  errorCountOverflow := LEConvertUInt32From(20, response);
end;

function TBrickletCO2V2.SetBootloaderMode(const mode: byte): byte;
var request, response: TByteArray;
begin
  CheckValidity;
  request := (ipcon as TIPConnection).CreateRequestPacket(self, BRICKLET_CO2_V2_FUNCTION_SET_BOOTLOADER_MODE, 9);
  LEConvertUInt8To(mode, 8, request);
  response := SendRequest(request, 9);
  result := LEConvertUInt8From(8, response);
end;

function TBrickletCO2V2.GetBootloaderMode: byte;
var request, response: TByteArray;
begin
  CheckValidity;
  request := (ipcon as TIPConnection).CreateRequestPacket(self, BRICKLET_CO2_V2_FUNCTION_GET_BOOTLOADER_MODE, 8);
  response := SendRequest(request, 9);
  result := LEConvertUInt8From(8, response);
end;

procedure TBrickletCO2V2.SetWriteFirmwarePointer(const pointer: longword);
var request: TByteArray;
begin
  CheckValidity;
  request := (ipcon as TIPConnection).CreateRequestPacket(self, BRICKLET_CO2_V2_FUNCTION_SET_WRITE_FIRMWARE_POINTER, 12);
  LEConvertUInt32To(pointer, 8, request);
  SendRequest(request, 0);
end;

function TBrickletCO2V2.WriteFirmware(const data: array of byte): byte;
var request, response: TByteArray; i: longint;
begin
  CheckValidity;
  request := (ipcon as TIPConnection).CreateRequestPacket(self, BRICKLET_CO2_V2_FUNCTION_WRITE_FIRMWARE, 72);
  if (Length(data) <> 64) then raise EInvalidParameterException.Create('Data has to be exactly 64 items long');
  for i := 0 to Length(data) - 1 do LEConvertUInt8To(data[i], 8 + (i * 1), request);
  response := SendRequest(request, 9);
  result := LEConvertUInt8From(8, response);
end;

procedure TBrickletCO2V2.SetStatusLEDConfig(const config: byte);
var request: TByteArray;
begin
  CheckValidity;
  request := (ipcon as TIPConnection).CreateRequestPacket(self, BRICKLET_CO2_V2_FUNCTION_SET_STATUS_LED_CONFIG, 9);
  LEConvertUInt8To(config, 8, request);
  SendRequest(request, 0);
end;

function TBrickletCO2V2.GetStatusLEDConfig: byte;
var request, response: TByteArray;
begin
  CheckValidity;
  request := (ipcon as TIPConnection).CreateRequestPacket(self, BRICKLET_CO2_V2_FUNCTION_GET_STATUS_LED_CONFIG, 8);
  response := SendRequest(request, 9);
  result := LEConvertUInt8From(8, response);
end;

function TBrickletCO2V2.GetChipTemperature: smallint;
var request, response: TByteArray;
begin
  CheckValidity;
  request := (ipcon as TIPConnection).CreateRequestPacket(self, BRICKLET_CO2_V2_FUNCTION_GET_CHIP_TEMPERATURE, 8);
  response := SendRequest(request, 10);
  result := LEConvertInt16From(8, response);
end;

procedure TBrickletCO2V2.Reset;
var request: TByteArray;
begin
  CheckValidity;
  request := (ipcon as TIPConnection).CreateRequestPacket(self, BRICKLET_CO2_V2_FUNCTION_RESET, 8);
  SendRequest(request, 0);
end;

procedure TBrickletCO2V2.WriteUID(const uid: longword);
var request: TByteArray;
begin
  CheckValidity;
  request := (ipcon as TIPConnection).CreateRequestPacket(self, BRICKLET_CO2_V2_FUNCTION_WRITE_UID, 12);
  LEConvertUInt32To(uid, 8, request);
  SendRequest(request, 0);
end;

function TBrickletCO2V2.ReadUID: longword;
var request, response: TByteArray;
begin
  CheckValidity;
  request := (ipcon as TIPConnection).CreateRequestPacket(self, BRICKLET_CO2_V2_FUNCTION_READ_UID, 8);
  response := SendRequest(request, 12);
  result := LEConvertUInt32From(8, response);
end;

procedure TBrickletCO2V2.GetIdentity(out uid: string; out connectedUid: string; out position: char; out hardwareVersion: TVersionNumber; out firmwareVersion: TVersionNumber; out deviceIdentifier: word);
var request, response: TByteArray; i: longint;
begin
  CheckValidity;
  request := (ipcon as TIPConnection).CreateRequestPacket(self, BRICKLET_CO2_V2_FUNCTION_GET_IDENTITY, 8);
  response := SendRequest(request, 33);
  uid := LEConvertStringFrom(8, 8, response);
  connectedUid := LEConvertStringFrom(16, 8, response);
  position := LEConvertCharFrom(24, response);
  for i := 0 to 2 do hardwareVersion[i] := LEConvertUInt8From(25 + (i * 1), response);
  for i := 0 to 2 do firmwareVersion[i] := LEConvertUInt8From(28 + (i * 1), response);
  deviceIdentifier := LEConvertUInt16From(31, response);
end;

procedure TBrickletCO2V2.CallbackWrapperAllValues(const packet: TByteArray);
var co2Concentration: word; temperature: smallint; humidity: word;
begin
  if (Length(packet) <> 14) then begin
    exit; { Silently ignoring callback with wrong length }
  end;
  co2Concentration := LEConvertUInt16From(8, packet);
  temperature := LEConvertInt16From(10, packet);
  humidity := LEConvertUInt16From(12, packet);
  if (Assigned(allValuesCallback)) then begin
    allValuesCallback(self, co2Concentration, temperature, humidity);
  end;
end;

procedure TBrickletCO2V2.CallbackWrapperCO2Concentration(const packet: TByteArray);
var co2Concentration: word;
begin
  if (Length(packet) <> 10) then begin
    exit; { Silently ignoring callback with wrong length }
  end;
  co2Concentration := LEConvertUInt16From(8, packet);
  if (Assigned(co2ConcentrationCallback)) then begin
    co2ConcentrationCallback(self, co2Concentration);
  end;
end;

procedure TBrickletCO2V2.CallbackWrapperTemperature(const packet: TByteArray);
var temperature: smallint;
begin
  if (Length(packet) <> 10) then begin
    exit; { Silently ignoring callback with wrong length }
  end;
  temperature := LEConvertInt16From(8, packet);
  if (Assigned(temperatureCallback)) then begin
    temperatureCallback(self, temperature);
  end;
end;

procedure TBrickletCO2V2.CallbackWrapperHumidity(const packet: TByteArray);
var humidity: word;
begin
  if (Length(packet) <> 10) then begin
    exit; { Silently ignoring callback with wrong length }
  end;
  humidity := LEConvertUInt16From(8, packet);
  if (Assigned(humidityCallback)) then begin
    humidityCallback(self, humidity);
  end;
end;

end.
