{
  This file was automatically generated on 2020-05-19.

  Delphi/Lazarus Bindings Version 2.1.28

  If you have a bugfix for this file and want to commit it,
  please fix the bug in the generator. You can find a link
  to the generators git on tinkerforge.com
}

unit BrickletDMX;

{$ifdef FPC}{$mode OBJFPC}{$H+}{$endif}

interface

uses
  Device, IPConnection, LEConverter, Math, SyncObjs;

const
  BRICKLET_DMX_DEVICE_IDENTIFIER = 285;
  BRICKLET_DMX_DEVICE_DISPLAY_NAME = 'DMX Bricklet';

  BRICKLET_DMX_FUNCTION_SET_DMX_MODE = 1;
  BRICKLET_DMX_FUNCTION_GET_DMX_MODE = 2;
  BRICKLET_DMX_FUNCTION_WRITE_FRAME_LOW_LEVEL = 3;
  BRICKLET_DMX_FUNCTION_READ_FRAME_LOW_LEVEL = 4;
  BRICKLET_DMX_FUNCTION_SET_FRAME_DURATION = 5;
  BRICKLET_DMX_FUNCTION_GET_FRAME_DURATION = 6;
  BRICKLET_DMX_FUNCTION_GET_FRAME_ERROR_COUNT = 7;
  BRICKLET_DMX_FUNCTION_SET_COMMUNICATION_LED_CONFIG = 8;
  BRICKLET_DMX_FUNCTION_GET_COMMUNICATION_LED_CONFIG = 9;
  BRICKLET_DMX_FUNCTION_SET_ERROR_LED_CONFIG = 10;
  BRICKLET_DMX_FUNCTION_GET_ERROR_LED_CONFIG = 11;
  BRICKLET_DMX_FUNCTION_SET_FRAME_CALLBACK_CONFIG = 12;
  BRICKLET_DMX_FUNCTION_GET_FRAME_CALLBACK_CONFIG = 13;
  BRICKLET_DMX_FUNCTION_GET_SPITFP_ERROR_COUNT = 234;
  BRICKLET_DMX_FUNCTION_SET_BOOTLOADER_MODE = 235;
  BRICKLET_DMX_FUNCTION_GET_BOOTLOADER_MODE = 236;
  BRICKLET_DMX_FUNCTION_SET_WRITE_FIRMWARE_POINTER = 237;
  BRICKLET_DMX_FUNCTION_WRITE_FIRMWARE = 238;
  BRICKLET_DMX_FUNCTION_SET_STATUS_LED_CONFIG = 239;
  BRICKLET_DMX_FUNCTION_GET_STATUS_LED_CONFIG = 240;
  BRICKLET_DMX_FUNCTION_GET_CHIP_TEMPERATURE = 242;
  BRICKLET_DMX_FUNCTION_RESET = 243;
  BRICKLET_DMX_FUNCTION_WRITE_UID = 248;
  BRICKLET_DMX_FUNCTION_READ_UID = 249;
  BRICKLET_DMX_FUNCTION_GET_IDENTITY = 255;

  BRICKLET_DMX_CALLBACK_FRAME_STARTED = 14;
  BRICKLET_DMX_CALLBACK_FRAME_AVAILABLE = 15;
  BRICKLET_DMX_CALLBACK_FRAME_LOW_LEVEL = 16;
  BRICKLET_DMX_CALLBACK_FRAME_ERROR_COUNT = 17;

  BRICKLET_DMX_DMX_MODE_MASTER = 0;
  BRICKLET_DMX_DMX_MODE_SLAVE = 1;
  BRICKLET_DMX_COMMUNICATION_LED_CONFIG_OFF = 0;
  BRICKLET_DMX_COMMUNICATION_LED_CONFIG_ON = 1;
  BRICKLET_DMX_COMMUNICATION_LED_CONFIG_SHOW_HEARTBEAT = 2;
  BRICKLET_DMX_COMMUNICATION_LED_CONFIG_SHOW_COMMUNICATION = 3;
  BRICKLET_DMX_ERROR_LED_CONFIG_OFF = 0;
  BRICKLET_DMX_ERROR_LED_CONFIG_ON = 1;
  BRICKLET_DMX_ERROR_LED_CONFIG_SHOW_HEARTBEAT = 2;
  BRICKLET_DMX_ERROR_LED_CONFIG_SHOW_ERROR = 3;
  BRICKLET_DMX_BOOTLOADER_MODE_BOOTLOADER = 0;
  BRICKLET_DMX_BOOTLOADER_MODE_FIRMWARE = 1;
  BRICKLET_DMX_BOOTLOADER_MODE_BOOTLOADER_WAIT_FOR_REBOOT = 2;
  BRICKLET_DMX_BOOTLOADER_MODE_FIRMWARE_WAIT_FOR_REBOOT = 3;
  BRICKLET_DMX_BOOTLOADER_MODE_FIRMWARE_WAIT_FOR_ERASE_AND_REBOOT = 4;
  BRICKLET_DMX_BOOTLOADER_STATUS_OK = 0;
  BRICKLET_DMX_BOOTLOADER_STATUS_INVALID_MODE = 1;
  BRICKLET_DMX_BOOTLOADER_STATUS_NO_CHANGE = 2;
  BRICKLET_DMX_BOOTLOADER_STATUS_ENTRY_FUNCTION_NOT_PRESENT = 3;
  BRICKLET_DMX_BOOTLOADER_STATUS_DEVICE_IDENTIFIER_INCORRECT = 4;
  BRICKLET_DMX_BOOTLOADER_STATUS_CRC_MISMATCH = 5;
  BRICKLET_DMX_STATUS_LED_CONFIG_OFF = 0;
  BRICKLET_DMX_STATUS_LED_CONFIG_ON = 1;
  BRICKLET_DMX_STATUS_LED_CONFIG_SHOW_HEARTBEAT = 2;
  BRICKLET_DMX_STATUS_LED_CONFIG_SHOW_STATUS = 3;

type
  TArray0To2OfUInt8 = array [0..2] of byte;
  TArray0To55OfUInt8 = array [0..55] of byte;
  TArray0To59OfUInt8 = array [0..59] of byte;
  TArray0To63OfUInt8 = array [0..63] of byte;
  TArrayOfUInt8 = array of byte;

  TFrameHighLevelCallbackState = record data: TArrayOfUInt8; length: word; end;

  TBrickletDMX = class;
  TBrickletDMXNotifyFrameStarted = procedure(sender: TBrickletDMX) of object;
  TBrickletDMXNotifyFrameAvailable = procedure(sender: TBrickletDMX; const frameNumber: longword) of object;
  TBrickletDMXNotifyFrameLowLevel = procedure(sender: TBrickletDMX; const frameLength: word; const frameChunkOffset: word; const frameChunkData: TArray0To55OfUInt8; const frameNumber: longword) of object;
  TBrickletDMXNotifyFrame = procedure(sender: TBrickletDMX; const frame: TArrayOfUInt8; const frameNumber: longword) of object;
  TBrickletDMXNotifyFrameErrorCount = procedure(sender: TBrickletDMX; const overrunErrorCount: longword; const framingErrorCount: longword) of object;

  /// <summary>
  ///  DMX master and slave
  /// </summary>
  TBrickletDMX = class(TDevice)
  private
    streamMutex: TCriticalSection;
    frameHighLevelCallbackState: TFrameHighLevelCallbackState;
    frameStartedCallback: TBrickletDMXNotifyFrameStarted;
    frameAvailableCallback: TBrickletDMXNotifyFrameAvailable;
    frameLowLevelCallback: TBrickletDMXNotifyFrameLowLevel;
    frameCallback: TBrickletDMXNotifyFrame;
    frameErrorCountCallback: TBrickletDMXNotifyFrameErrorCount;
  protected
    procedure CallbackWrapperFrameStarted(const packet: TByteArray); virtual;
    procedure CallbackWrapperFrameAvailable(const packet: TByteArray); virtual;
    procedure CallbackWrapperFrameLowLevel(const packet: TByteArray); virtual;
    procedure CallbackWrapperFrameErrorCount(const packet: TByteArray); virtual;
  public
    /// <summary>
    ///  Creates an object with the unique device ID <c>uid</c>. This object can
    ///  then be added to the IP connection.
    /// </summary>
    constructor Create(const uid: string; ipcon_: TIPConnection);

    /// <summary>
    ///  Sets the DMX mode to either master or slave.
    ///  
    ///  Calling this function sets frame number to 0.
    /// </summary>
    procedure SetDMXMode(const dmxMode: byte); virtual;

    /// <summary>
    ///  Returns the DMX mode, as set by <see cref="BrickletDMX.TBrickletDMX.SetDMXMode"/>.
    /// </summary>
    function GetDMXMode: byte; virtual;

    /// <summary>
    ///  Writes a DMX frame. The maximum frame size is 512 byte. Each byte represents one channel.
    ///  
    ///  The next frame can be written after the <see cref="BrickletDMX.TBrickletDMX.OnFrameStarted"/> callback was called. The frame
    ///  is double buffered, so a new frame can be written as soon as the writing of the prior frame
    ///  starts.
    ///  
    ///  The data will be transfered when the next frame duration ends, see <see cref="BrickletDMX.TBrickletDMX.SetFrameDuration"/>.
    ///  
    ///  Generic approach:
    ///  
    ///  * Set the frame duration to a value that represents the number of frames per second you want to achieve.
    ///  * Set channels for first frame.
    ///  * Wait for the <see cref="BrickletDMX.TBrickletDMX.OnFrameStarted"/> callback.
    ///  * Set channels for next frame.
    ///  * Wait for the <see cref="BrickletDMX.TBrickletDMX.OnFrameStarted"/> callback.
    ///  * and so on.
    ///  
    ///  This approach ensures that you can set new DMX data with a fixed frame rate.
    ///  
    ///  This function can only be called in master mode.
    /// </summary>
    procedure WriteFrameLowLevel(const frameLength: word; const frameChunkOffset: word; const frameChunkData: TArray0To59OfUInt8); virtual;

    /// <summary>
    ///  Writes a DMX frame. The maximum frame size is 512 byte. Each byte represents one channel.
    ///  
    ///  The next frame can be written after the <see cref="BrickletDMX.TBrickletDMX.OnFrameStarted"/> callback was called. The frame
    ///  is double buffered, so a new frame can be written as soon as the writing of the prior frame
    ///  starts.
    ///  
    ///  The data will be transfered when the next frame duration ends, see <see cref="BrickletDMX.TBrickletDMX.SetFrameDuration"/>.
    ///  
    ///  Generic approach:
    ///  
    ///  * Set the frame duration to a value that represents the number of frames per second you want to achieve.
    ///  * Set channels for first frame.
    ///  * Wait for the <see cref="BrickletDMX.TBrickletDMX.OnFrameStarted"/> callback.
    ///  * Set channels for next frame.
    ///  * Wait for the <see cref="BrickletDMX.TBrickletDMX.OnFrameStarted"/> callback.
    ///  * and so on.
    ///  
    ///  This approach ensures that you can set new DMX data with a fixed frame rate.
    ///  
    ///  This function can only be called in master mode.
    /// </summary>
    procedure WriteFrame(const frame: array of byte); virtual;

    /// <summary>
    ///  Returns the last frame that was written by the DMX master. The size of the array
    ///  is equivalent to the number of channels in the frame. Each byte represents one channel.
    ///  
    ///  The next frame is available after the <see cref="BrickletDMX.TBrickletDMX.OnFrameAvailable"/> callback was called.
    ///  
    ///  Generic approach:
    ///  
    ///  * Call <see cref="BrickletDMX.TBrickletDMX.ReadFrame"/> to get first frame.
    ///  * Wait for the <see cref="BrickletDMX.TBrickletDMX.OnFrameAvailable"/> callback.
    ///  * Call <see cref="BrickletDMX.TBrickletDMX.ReadFrame"/> to get second frame.
    ///  * Wait for the <see cref="BrickletDMX.TBrickletDMX.OnFrameAvailable"/> callback.
    ///  * and so on.
    ///  
    ///  Instead of polling this function you can also use the <see cref="BrickletDMX.TBrickletDMX.OnFrame"/> callback.
    ///  You can enable it with <see cref="BrickletDMX.TBrickletDMX.SetFrameCallbackConfig"/>.
    ///  
    ///  The frame number starts at 0 and it is increased by one with each received frame.
    ///  
    ///  This function can only be called in slave mode.
    /// </summary>
    procedure ReadFrameLowLevel(out frameLength: word; out frameChunkOffset: word; out frameChunkData: TArray0To55OfUInt8; out frameNumber: longword); virtual;

    /// <summary>
    ///  Returns the last frame that was written by the DMX master. The size of the array
    ///  is equivalent to the number of channels in the frame. Each byte represents one channel.
    ///  
    ///  The next frame is available after the <see cref="BrickletDMX.TBrickletDMX.OnFrameAvailable"/> callback was called.
    ///  
    ///  Generic approach:
    ///  
    ///  * Call <see cref="BrickletDMX.TBrickletDMX.ReadFrame"/> to get first frame.
    ///  * Wait for the <see cref="BrickletDMX.TBrickletDMX.OnFrameAvailable"/> callback.
    ///  * Call <see cref="BrickletDMX.TBrickletDMX.ReadFrame"/> to get second frame.
    ///  * Wait for the <see cref="BrickletDMX.TBrickletDMX.OnFrameAvailable"/> callback.
    ///  * and so on.
    ///  
    ///  Instead of polling this function you can also use the <see cref="BrickletDMX.TBrickletDMX.OnFrame"/> callback.
    ///  You can enable it with <see cref="BrickletDMX.TBrickletDMX.SetFrameCallbackConfig"/>.
    ///  
    ///  The frame number starts at 0 and it is increased by one with each received frame.
    ///  
    ///  This function can only be called in slave mode.
    /// </summary>
    procedure ReadFrame(out frame: TArrayOfUInt8; out frameNumber: longword); virtual;

    /// <summary>
    ///  Sets the duration of a frame.
    ///  
    ///  Example: If you want to achieve 20 frames per second, you should
    ///  set the frame duration to 50ms (50ms * 20 = 1 second).
    ///  
    ///  If you always want to send a frame as fast as possible you can set
    ///  this value to 0.
    ///  
    ///  This setting is only used in master mode.
    /// </summary>
    procedure SetFrameDuration(const frameDuration: word); virtual;

    /// <summary>
    ///  Returns the frame duration as set by <see cref="BrickletDMX.TBrickletDMX.SetFrameDuration"/>.
    /// </summary>
    function GetFrameDuration: word; virtual;

    /// <summary>
    ///  Returns the current number of overrun and framing errors.
    /// </summary>
    procedure GetFrameErrorCount(out overrunErrorCount: longword; out framingErrorCount: longword); virtual;

    /// <summary>
    ///  Sets the communication LED configuration. By default the LED shows
    ///  communication traffic, it flickers once for every 10 received data packets.
    ///  
    ///  You can also turn the LED permanently on/off or show a heartbeat.
    ///  
    ///  If the Bricklet is in bootloader mode, the LED is off.
    /// </summary>
    procedure SetCommunicationLEDConfig(const config: byte); virtual;

    /// <summary>
    ///  Returns the configuration as set by <see cref="BrickletDMX.TBrickletDMX.SetCommunicationLEDConfig"/>
    /// </summary>
    function GetCommunicationLEDConfig: byte; virtual;

    /// <summary>
    ///  Sets the error LED configuration.
    ///  
    ///  By default the error LED turns on if there is any error (see <see cref="BrickletDMX.TBrickletDMX.OnFrameErrorCount"/>
    ///  callback). If you call this function with the Show-Error option again, the LED
    ///  will turn off until the next error occurs.
    ///  
    ///  You can also turn the LED permanently on/off or show a heartbeat.
    ///  
    ///  If the Bricklet is in bootloader mode, the LED is off.
    /// </summary>
    procedure SetErrorLEDConfig(const config: byte); virtual;

    /// <summary>
    ///  Returns the configuration as set by <see cref="BrickletDMX.TBrickletDMX.SetErrorLEDConfig"/>.
    /// </summary>
    function GetErrorLEDConfig: byte; virtual;

    /// <summary>
    ///  Enables/Disables the different callbacks. By default the
    ///  <see cref="BrickletDMX.TBrickletDMX.OnFrameStarted"/> callback and <see cref="BrickletDMX.TBrickletDMX.OnFrameAvailable"/> callback are enabled while
    ///  the <see cref="BrickletDMX.TBrickletDMX.OnFrame"/> callback and <see cref="BrickletDMX.TBrickletDMX.OnFrameErrorCount"/> callback are disabled.
    ///  
    ///  If you want to use the <see cref="BrickletDMX.TBrickletDMX.OnFrame"/> callback you can enable it and disable
    ///  the cb:`Frame Available` callback at the same time. It becomes redundant in
    ///  this case.
    /// </summary>
    procedure SetFrameCallbackConfig(const frameStartedCallbackEnabled: boolean; const frameAvailableCallbackEnabled: boolean; const frameCallbackEnabled: boolean; const frameErrorCountCallbackEnabled: boolean); virtual;

    /// <summary>
    ///  Returns the frame callback config as set by <see cref="BrickletDMX.TBrickletDMX.SetFrameCallbackConfig"/>.
    /// </summary>
    procedure GetFrameCallbackConfig(out frameStartedCallbackEnabled: boolean; out frameAvailableCallbackEnabled: boolean; out frameCallbackEnabled: boolean; out frameErrorCountCallbackEnabled: boolean); virtual;

    /// <summary>
    ///  Returns the error count for the communication between Brick and Bricklet.
    ///  
    ///  The errors are divided into
    ///  
    ///  * ACK checksum errors,
    ///  * message checksum errors,
    ///  * framing errors and
    ///  * overflow errors.
    ///  
    ///  The errors counts are for errors that occur on the Bricklet side. All
    ///  Bricks have a similar function that returns the errors on the Brick side.
    /// </summary>
    procedure GetSPITFPErrorCount(out errorCountAckChecksum: longword; out errorCountMessageChecksum: longword; out errorCountFrame: longword; out errorCountOverflow: longword); virtual;

    /// <summary>
    ///  Sets the bootloader mode and returns the status after the requested
    ///  mode change was instigated.
    ///  
    ///  You can change from bootloader mode to firmware mode and vice versa. A change
    ///  from bootloader mode to firmware mode will only take place if the entry function,
    ///  device identifier and CRC are present and correct.
    ///  
    ///  This function is used by Brick Viewer during flashing. It should not be
    ///  necessary to call it in a normal user program.
    /// </summary>
    function SetBootloaderMode(const mode: byte): byte; virtual;

    /// <summary>
    ///  Returns the current bootloader mode, see <see cref="BrickletDMX.TBrickletDMX.SetBootloaderMode"/>.
    /// </summary>
    function GetBootloaderMode: byte; virtual;

    /// <summary>
    ///  Sets the firmware pointer for <see cref="BrickletDMX.TBrickletDMX.WriteFirmware"/>. The pointer has
    ///  to be increased by chunks of size 64. The data is written to flash
    ///  every 4 chunks (which equals to one page of size 256).
    ///  
    ///  This function is used by Brick Viewer during flashing. It should not be
    ///  necessary to call it in a normal user program.
    /// </summary>
    procedure SetWriteFirmwarePointer(const pointer: longword); virtual;

    /// <summary>
    ///  Writes 64 Bytes of firmware at the position as written by
    ///  <see cref="BrickletDMX.TBrickletDMX.SetWriteFirmwarePointer"/> before. The firmware is written
    ///  to flash every 4 chunks.
    ///  
    ///  You can only write firmware in bootloader mode.
    ///  
    ///  This function is used by Brick Viewer during flashing. It should not be
    ///  necessary to call it in a normal user program.
    /// </summary>
    function WriteFirmware(const data: array of byte): byte; virtual;

    /// <summary>
    ///  Sets the status LED configuration. By default the LED shows
    ///  communication traffic between Brick and Bricklet, it flickers once
    ///  for every 10 received data packets.
    ///  
    ///  You can also turn the LED permanently on/off or show a heartbeat.
    ///  
    ///  If the Bricklet is in bootloader mode, the LED is will show heartbeat by default.
    /// </summary>
    procedure SetStatusLEDConfig(const config: byte); virtual;

    /// <summary>
    ///  Returns the configuration as set by <see cref="BrickletDMX.TBrickletDMX.SetStatusLEDConfig"/>
    /// </summary>
    function GetStatusLEDConfig: byte; virtual;

    /// <summary>
    ///  Returns the temperature as measured inside the microcontroller. The
    ///  value returned is not the ambient temperature!
    ///  
    ///  The temperature is only proportional to the real temperature and it has bad
    ///  accuracy. Practically it is only useful as an indicator for
    ///  temperature changes.
    /// </summary>
    function GetChipTemperature: smallint; virtual;

    /// <summary>
    ///  Calling this function will reset the Bricklet. All configurations
    ///  will be lost.
    ///  
    ///  After a reset you have to create new device objects,
    ///  calling functions on the existing ones will result in
    ///  undefined behavior!
    /// </summary>
    procedure Reset; virtual;

    /// <summary>
    ///  Writes a new UID into flash. If you want to set a new UID
    ///  you have to decode the Base58 encoded UID string into an
    ///  integer first.
    ///  
    ///  We recommend that you use Brick Viewer to change the UID.
    /// </summary>
    procedure WriteUID(const uid: longword); virtual;

    /// <summary>
    ///  Returns the current UID as an integer. Encode as
    ///  Base58 to get the usual string version.
    /// </summary>
    function ReadUID: longword; virtual;

    /// <summary>
    ///  Returns the UID, the UID where the Bricklet is connected to,
    ///  the position, the hardware and firmware version as well as the
    ///  device identifier.
    ///  
    ///  The position can be 'a', 'b', 'c', 'd', 'e', 'f', 'g' or 'h' (Bricklet Port).
    ///  The Raspberry Pi HAT (Zero) Brick is always at position 'i' and the Bricklet
    ///  connected to an :ref:`Isolator Bricklet &lt;isolator_bricklet&gt;` is always as
    ///  position 'z'.
    ///  
    ///  The device identifier numbers can be found :ref:`here &lt;device_identifier&gt;`.
    ///  |device_identifier_constant|
    /// </summary>
    procedure GetIdentity(out uid: string; out connectedUid: string; out position: char; out hardwareVersion: TVersionNumber; out firmwareVersion: TVersionNumber; out deviceIdentifier: word); override;

    /// <summary>
    ///  This callback is triggered as soon as a new frame write is started.
    ///  You should send the data for the next frame directly after this callback
    ///  was triggered.
    ///  
    ///  For an explanation of the general approach see <see cref="BrickletDMX.TBrickletDMX.WriteFrame"/>.
    ///  
    ///  This callback can be enabled via <see cref="BrickletDMX.TBrickletDMX.SetFrameCallbackConfig"/>.
    ///  
    ///  This callback can only be triggered in master mode.
    /// </summary>
    property OnFrameStarted: TBrickletDMXNotifyFrameStarted read frameStartedCallback write frameStartedCallback;

    /// <summary>
    ///  This callback is triggered in slave mode when a new frame was received from the DMX master
    ///  and it can be read out. You have to read the frame before the master has written
    ///  the next frame, see <see cref="BrickletDMX.TBrickletDMX.ReadFrame"/> for more details.
    ///  
    ///  The parameter is the frame number, it is increased by one with each received frame.
    ///  
    ///  This callback can be enabled via <see cref="BrickletDMX.TBrickletDMX.SetFrameCallbackConfig"/>.
    ///  
    ///  This callback can only be triggered in slave mode.
    /// </summary>
    property OnFrameAvailable: TBrickletDMXNotifyFrameAvailable read frameAvailableCallback write frameAvailableCallback;

    /// <summary>
    ///  <see cref="BrickletDMX.TBrickletDMX.OnFrame"/>
    /// </summary>
    property OnFrameLowLevel: TBrickletDMXNotifyFrameLowLevel read frameLowLevelCallback write frameLowLevelCallback;

    /// <summary>
    ///  This callback is called as soon as a new frame is available
    ///  (written by the DMX master).
    ///  
    ///  The size of the array is equivalent to the number of channels in
    ///  the frame. Each byte represents one channel.
    ///  
    ///  This callback can be enabled via <see cref="BrickletDMX.TBrickletDMX.SetFrameCallbackConfig"/>.
    ///  
    ///  This callback can only be triggered in slave mode.
    ///  
    ///  <note>
    ///   If reconstructing the value fails, the callback is triggered with nil for frame.
    ///  </note>
    /// </summary>
    property OnFrame: TBrickletDMXNotifyFrame read frameCallback write frameCallback;

    /// <summary>
    ///  This callback is called if a new error occurs. It returns
    ///  the current overrun and framing error count.
    /// </summary>
    property OnFrameErrorCount: TBrickletDMXNotifyFrameErrorCount read frameErrorCountCallback write frameErrorCountCallback;
  end;

implementation

constructor TBrickletDMX.Create(const uid: string; ipcon_: TIPConnection);
begin
  inherited Create(uid, ipcon_, BRICKLET_DMX_DEVICE_IDENTIFIER, BRICKLET_DMX_DEVICE_DISPLAY_NAME);
  apiVersion[0] := 2;
  apiVersion[1] := 0;
  apiVersion[2] := 0;

  responseExpected[BRICKLET_DMX_FUNCTION_SET_DMX_MODE] := DEVICE_RESPONSE_EXPECTED_FALSE;
  responseExpected[BRICKLET_DMX_FUNCTION_GET_DMX_MODE] := DEVICE_RESPONSE_EXPECTED_ALWAYS_TRUE;
  responseExpected[BRICKLET_DMX_FUNCTION_WRITE_FRAME_LOW_LEVEL] := DEVICE_RESPONSE_EXPECTED_TRUE;
  responseExpected[BRICKLET_DMX_FUNCTION_READ_FRAME_LOW_LEVEL] := DEVICE_RESPONSE_EXPECTED_ALWAYS_TRUE;
  responseExpected[BRICKLET_DMX_FUNCTION_SET_FRAME_DURATION] := DEVICE_RESPONSE_EXPECTED_FALSE;
  responseExpected[BRICKLET_DMX_FUNCTION_GET_FRAME_DURATION] := DEVICE_RESPONSE_EXPECTED_ALWAYS_TRUE;
  responseExpected[BRICKLET_DMX_FUNCTION_GET_FRAME_ERROR_COUNT] := DEVICE_RESPONSE_EXPECTED_ALWAYS_TRUE;
  responseExpected[BRICKLET_DMX_FUNCTION_SET_COMMUNICATION_LED_CONFIG] := DEVICE_RESPONSE_EXPECTED_FALSE;
  responseExpected[BRICKLET_DMX_FUNCTION_GET_COMMUNICATION_LED_CONFIG] := DEVICE_RESPONSE_EXPECTED_ALWAYS_TRUE;
  responseExpected[BRICKLET_DMX_FUNCTION_SET_ERROR_LED_CONFIG] := DEVICE_RESPONSE_EXPECTED_FALSE;
  responseExpected[BRICKLET_DMX_FUNCTION_GET_ERROR_LED_CONFIG] := DEVICE_RESPONSE_EXPECTED_ALWAYS_TRUE;
  responseExpected[BRICKLET_DMX_FUNCTION_SET_FRAME_CALLBACK_CONFIG] := DEVICE_RESPONSE_EXPECTED_TRUE;
  responseExpected[BRICKLET_DMX_FUNCTION_GET_FRAME_CALLBACK_CONFIG] := DEVICE_RESPONSE_EXPECTED_ALWAYS_TRUE;
  responseExpected[BRICKLET_DMX_FUNCTION_GET_SPITFP_ERROR_COUNT] := DEVICE_RESPONSE_EXPECTED_ALWAYS_TRUE;
  responseExpected[BRICKLET_DMX_FUNCTION_SET_BOOTLOADER_MODE] := DEVICE_RESPONSE_EXPECTED_ALWAYS_TRUE;
  responseExpected[BRICKLET_DMX_FUNCTION_GET_BOOTLOADER_MODE] := DEVICE_RESPONSE_EXPECTED_ALWAYS_TRUE;
  responseExpected[BRICKLET_DMX_FUNCTION_SET_WRITE_FIRMWARE_POINTER] := DEVICE_RESPONSE_EXPECTED_FALSE;
  responseExpected[BRICKLET_DMX_FUNCTION_WRITE_FIRMWARE] := DEVICE_RESPONSE_EXPECTED_ALWAYS_TRUE;
  responseExpected[BRICKLET_DMX_FUNCTION_SET_STATUS_LED_CONFIG] := DEVICE_RESPONSE_EXPECTED_FALSE;
  responseExpected[BRICKLET_DMX_FUNCTION_GET_STATUS_LED_CONFIG] := DEVICE_RESPONSE_EXPECTED_ALWAYS_TRUE;
  responseExpected[BRICKLET_DMX_FUNCTION_GET_CHIP_TEMPERATURE] := DEVICE_RESPONSE_EXPECTED_ALWAYS_TRUE;
  responseExpected[BRICKLET_DMX_FUNCTION_RESET] := DEVICE_RESPONSE_EXPECTED_FALSE;
  responseExpected[BRICKLET_DMX_FUNCTION_WRITE_UID] := DEVICE_RESPONSE_EXPECTED_FALSE;
  responseExpected[BRICKLET_DMX_FUNCTION_READ_UID] := DEVICE_RESPONSE_EXPECTED_ALWAYS_TRUE;
  responseExpected[BRICKLET_DMX_FUNCTION_GET_IDENTITY] := DEVICE_RESPONSE_EXPECTED_ALWAYS_TRUE;

  streamMutex := TCriticalSection.Create;

  SetLength(frameHighLevelCallbackState.data, 0);
  frameHighLevelCallbackState.data := nil;
  frameHighLevelCallbackState.length := 0;

  callbackWrappers[BRICKLET_DMX_CALLBACK_FRAME_STARTED] := {$ifdef FPC}@{$endif}CallbackWrapperFrameStarted;
  callbackWrappers[BRICKLET_DMX_CALLBACK_FRAME_AVAILABLE] := {$ifdef FPC}@{$endif}CallbackWrapperFrameAvailable;
  callbackWrappers[BRICKLET_DMX_CALLBACK_FRAME_LOW_LEVEL] := {$ifdef FPC}@{$endif}CallbackWrapperFrameLowLevel;
  callbackWrappers[BRICKLET_DMX_CALLBACK_FRAME_ERROR_COUNT] := {$ifdef FPC}@{$endif}CallbackWrapperFrameErrorCount;

  (ipcon as TIPConnection).AddDevice(self);
end;

procedure TBrickletDMX.SetDMXMode(const dmxMode: byte);
var request: TByteArray;
begin
  CheckValidity;
  request := (ipcon as TIPConnection).CreateRequestPacket(self, BRICKLET_DMX_FUNCTION_SET_DMX_MODE, 9);
  LEConvertUInt8To(dmxMode, 8, request);
  SendRequest(request, 0);
end;

function TBrickletDMX.GetDMXMode: byte;
var request, response: TByteArray;
begin
  CheckValidity;
  request := (ipcon as TIPConnection).CreateRequestPacket(self, BRICKLET_DMX_FUNCTION_GET_DMX_MODE, 8);
  response := SendRequest(request, 9);
  result := LEConvertUInt8From(8, response);
end;

procedure TBrickletDMX.WriteFrameLowLevel(const frameLength: word; const frameChunkOffset: word; const frameChunkData: TArray0To59OfUInt8);
var request: TByteArray; i: longint;
begin
  CheckValidity;
  request := (ipcon as TIPConnection).CreateRequestPacket(self, BRICKLET_DMX_FUNCTION_WRITE_FRAME_LOW_LEVEL, 72);
  LEConvertUInt16To(frameLength, 8, request);
  LEConvertUInt16To(frameChunkOffset, 10, request);
  for i := 0 to Length(frameChunkData) - 1 do LEConvertUInt8To(frameChunkData[i], 12 + (i * 1), request);
  SendRequest(request, 0);
end;

procedure TBrickletDMX.WriteFrame(const frame: array of byte);
var
  frameChunkOffset: word;
  frameChunkData: TArray0To59OfUInt8;
  frameChunkLength: word;
  frameLength: word;
begin
  if (Length(frame) > 65535) then begin
    raise EInvalidParameterException.Create('Frame can be at most 65535 items long');
  end;

  frameLength := Length(frame);
  frameChunkOffset := 0;

  if (frameLength = 0) then begin
    FillChar(frameChunkData[0], SizeOf(byte) * 60, 0);
    WriteFrameLowLevel(frameLength, frameChunkOffset, frameChunkData);
  end
  else begin
    streamMutex.Acquire;
    try
      while (frameChunkOffset < frameLength) do begin
        frameChunkLength := frameLength - frameChunkOffset;

        if (frameChunkLength > 60) then frameChunkLength := 60;

        FillChar(frameChunkData[0], SizeOf(byte) * 60, 0);
        Move(frame[frameChunkOffset], frameChunkData[0], SizeOf(byte) * frameChunkLength);

        WriteFrameLowLevel(frameLength, frameChunkOffset, frameChunkData);
        Inc(frameChunkOffset, 60);
      end;
    finally
      streamMutex.Release;
    end;
  end;
end;

procedure TBrickletDMX.ReadFrameLowLevel(out frameLength: word; out frameChunkOffset: word; out frameChunkData: TArray0To55OfUInt8; out frameNumber: longword);
var request, response: TByteArray; i: longint;
begin
  CheckValidity;
  request := (ipcon as TIPConnection).CreateRequestPacket(self, BRICKLET_DMX_FUNCTION_READ_FRAME_LOW_LEVEL, 8);
  response := SendRequest(request, 72);
  frameLength := LEConvertUInt16From(8, response);
  frameChunkOffset := LEConvertUInt16From(10, response);
  for i := 0 to 55 do frameChunkData[i] := LEConvertUInt8From(12 + (i * 1), response);
  frameNumber := LEConvertUInt32From(68, response);
end;

procedure TBrickletDMX.ReadFrame(out frame: TArrayOfUInt8; out frameNumber: longword);
var
  frameCurrentLength: word;
  frameLength: word;
  frameChunkOffset: word;
  frameChunkData: TArray0To55OfUInt8;
  frameOutOfSync: boolean;
  frameChunkLength: word;
begin
  streamMutex.Acquire;
  try
    frameLength := 0;
    ReadFrameLowLevel(frameLength, frameChunkOffset, frameChunkData, frameNumber);
    SetLength(frame, frameLength);
    frameOutOfSync := (frameChunkOffset <> 0);

    if ((not frameOutOfSync) and (frameLength > 0)) then begin
      frameChunkLength := frameLength - frameChunkOffset;
      if (frameChunkLength > 56) then frameChunkLength := 56;
      Move(frameChunkData, frame[0], SizeOf(byte) * frameChunkLength);
      frameCurrentLength := frameChunkLength;

      while ((not frameOutOfSync) and (frameCurrentLength < frameLength)) do begin
        ReadFrameLowLevel(frameLength, frameChunkOffset, frameChunkData, frameNumber);
        frameOutOfSync := frameChunkOffset <> frameCurrentLength;
        frameChunkLength := frameLength - frameChunkOffset;
        if (frameChunkLength > 56) then frameChunkLength := 56;
        Move(frameChunkData, frame[frameCurrentLength], SizeOf(byte) * frameChunkLength);
        Inc(frameCurrentLength, frameChunkLength);
      end;
    end;

    if (frameOutOfSync) then begin
      { Discard remaining stream to bring it back in-sync }
      while (frameChunkOffset + 56 < frameLength) do begin
        ReadFrameLowLevel(frameLength, frameChunkOffset, frameChunkData, frameNumber);
      end;

      raise EStreamOutOfSyncException.Create('Frame stream out-of-sync');
    end;
  finally
    streamMutex.Release;
  end;
end;

procedure TBrickletDMX.SetFrameDuration(const frameDuration: word);
var request: TByteArray;
begin
  CheckValidity;
  request := (ipcon as TIPConnection).CreateRequestPacket(self, BRICKLET_DMX_FUNCTION_SET_FRAME_DURATION, 10);
  LEConvertUInt16To(frameDuration, 8, request);
  SendRequest(request, 0);
end;

function TBrickletDMX.GetFrameDuration: word;
var request, response: TByteArray;
begin
  CheckValidity;
  request := (ipcon as TIPConnection).CreateRequestPacket(self, BRICKLET_DMX_FUNCTION_GET_FRAME_DURATION, 8);
  response := SendRequest(request, 10);
  result := LEConvertUInt16From(8, response);
end;

procedure TBrickletDMX.GetFrameErrorCount(out overrunErrorCount: longword; out framingErrorCount: longword);
var request, response: TByteArray;
begin
  CheckValidity;
  request := (ipcon as TIPConnection).CreateRequestPacket(self, BRICKLET_DMX_FUNCTION_GET_FRAME_ERROR_COUNT, 8);
  response := SendRequest(request, 16);
  overrunErrorCount := LEConvertUInt32From(8, response);
  framingErrorCount := LEConvertUInt32From(12, response);
end;

procedure TBrickletDMX.SetCommunicationLEDConfig(const config: byte);
var request: TByteArray;
begin
  CheckValidity;
  request := (ipcon as TIPConnection).CreateRequestPacket(self, BRICKLET_DMX_FUNCTION_SET_COMMUNICATION_LED_CONFIG, 9);
  LEConvertUInt8To(config, 8, request);
  SendRequest(request, 0);
end;

function TBrickletDMX.GetCommunicationLEDConfig: byte;
var request, response: TByteArray;
begin
  CheckValidity;
  request := (ipcon as TIPConnection).CreateRequestPacket(self, BRICKLET_DMX_FUNCTION_GET_COMMUNICATION_LED_CONFIG, 8);
  response := SendRequest(request, 9);
  result := LEConvertUInt8From(8, response);
end;

procedure TBrickletDMX.SetErrorLEDConfig(const config: byte);
var request: TByteArray;
begin
  CheckValidity;
  request := (ipcon as TIPConnection).CreateRequestPacket(self, BRICKLET_DMX_FUNCTION_SET_ERROR_LED_CONFIG, 9);
  LEConvertUInt8To(config, 8, request);
  SendRequest(request, 0);
end;

function TBrickletDMX.GetErrorLEDConfig: byte;
var request, response: TByteArray;
begin
  CheckValidity;
  request := (ipcon as TIPConnection).CreateRequestPacket(self, BRICKLET_DMX_FUNCTION_GET_ERROR_LED_CONFIG, 8);
  response := SendRequest(request, 9);
  result := LEConvertUInt8From(8, response);
end;

procedure TBrickletDMX.SetFrameCallbackConfig(const frameStartedCallbackEnabled: boolean; const frameAvailableCallbackEnabled: boolean; const frameCallbackEnabled: boolean; const frameErrorCountCallbackEnabled: boolean);
var request: TByteArray;
begin
  CheckValidity;
  request := (ipcon as TIPConnection).CreateRequestPacket(self, BRICKLET_DMX_FUNCTION_SET_FRAME_CALLBACK_CONFIG, 12);
  LEConvertBooleanTo(frameStartedCallbackEnabled, 8, request);
  LEConvertBooleanTo(frameAvailableCallbackEnabled, 9, request);
  LEConvertBooleanTo(frameCallbackEnabled, 10, request);
  LEConvertBooleanTo(frameErrorCountCallbackEnabled, 11, request);
  SendRequest(request, 0);
end;

procedure TBrickletDMX.GetFrameCallbackConfig(out frameStartedCallbackEnabled: boolean; out frameAvailableCallbackEnabled: boolean; out frameCallbackEnabled: boolean; out frameErrorCountCallbackEnabled: boolean);
var request, response: TByteArray;
begin
  CheckValidity;
  request := (ipcon as TIPConnection).CreateRequestPacket(self, BRICKLET_DMX_FUNCTION_GET_FRAME_CALLBACK_CONFIG, 8);
  response := SendRequest(request, 12);
  frameStartedCallbackEnabled := LEConvertBooleanFrom(8, response);
  frameAvailableCallbackEnabled := LEConvertBooleanFrom(9, response);
  frameCallbackEnabled := LEConvertBooleanFrom(10, response);
  frameErrorCountCallbackEnabled := LEConvertBooleanFrom(11, response);
end;

procedure TBrickletDMX.GetSPITFPErrorCount(out errorCountAckChecksum: longword; out errorCountMessageChecksum: longword; out errorCountFrame: longword; out errorCountOverflow: longword);
var request, response: TByteArray;
begin
  CheckValidity;
  request := (ipcon as TIPConnection).CreateRequestPacket(self, BRICKLET_DMX_FUNCTION_GET_SPITFP_ERROR_COUNT, 8);
  response := SendRequest(request, 24);
  errorCountAckChecksum := LEConvertUInt32From(8, response);
  errorCountMessageChecksum := LEConvertUInt32From(12, response);
  errorCountFrame := LEConvertUInt32From(16, response);
  errorCountOverflow := LEConvertUInt32From(20, response);
end;

function TBrickletDMX.SetBootloaderMode(const mode: byte): byte;
var request, response: TByteArray;
begin
  CheckValidity;
  request := (ipcon as TIPConnection).CreateRequestPacket(self, BRICKLET_DMX_FUNCTION_SET_BOOTLOADER_MODE, 9);
  LEConvertUInt8To(mode, 8, request);
  response := SendRequest(request, 9);
  result := LEConvertUInt8From(8, response);
end;

function TBrickletDMX.GetBootloaderMode: byte;
var request, response: TByteArray;
begin
  CheckValidity;
  request := (ipcon as TIPConnection).CreateRequestPacket(self, BRICKLET_DMX_FUNCTION_GET_BOOTLOADER_MODE, 8);
  response := SendRequest(request, 9);
  result := LEConvertUInt8From(8, response);
end;

procedure TBrickletDMX.SetWriteFirmwarePointer(const pointer: longword);
var request: TByteArray;
begin
  CheckValidity;
  request := (ipcon as TIPConnection).CreateRequestPacket(self, BRICKLET_DMX_FUNCTION_SET_WRITE_FIRMWARE_POINTER, 12);
  LEConvertUInt32To(pointer, 8, request);
  SendRequest(request, 0);
end;

function TBrickletDMX.WriteFirmware(const data: array of byte): byte;
var request, response: TByteArray; i: longint;
begin
  CheckValidity;
  request := (ipcon as TIPConnection).CreateRequestPacket(self, BRICKLET_DMX_FUNCTION_WRITE_FIRMWARE, 72);
  if (Length(data) <> 64) then raise EInvalidParameterException.Create('Data has to be exactly 64 items long');
  for i := 0 to Length(data) - 1 do LEConvertUInt8To(data[i], 8 + (i * 1), request);
  response := SendRequest(request, 9);
  result := LEConvertUInt8From(8, response);
end;

procedure TBrickletDMX.SetStatusLEDConfig(const config: byte);
var request: TByteArray;
begin
  CheckValidity;
  request := (ipcon as TIPConnection).CreateRequestPacket(self, BRICKLET_DMX_FUNCTION_SET_STATUS_LED_CONFIG, 9);
  LEConvertUInt8To(config, 8, request);
  SendRequest(request, 0);
end;

function TBrickletDMX.GetStatusLEDConfig: byte;
var request, response: TByteArray;
begin
  CheckValidity;
  request := (ipcon as TIPConnection).CreateRequestPacket(self, BRICKLET_DMX_FUNCTION_GET_STATUS_LED_CONFIG, 8);
  response := SendRequest(request, 9);
  result := LEConvertUInt8From(8, response);
end;

function TBrickletDMX.GetChipTemperature: smallint;
var request, response: TByteArray;
begin
  CheckValidity;
  request := (ipcon as TIPConnection).CreateRequestPacket(self, BRICKLET_DMX_FUNCTION_GET_CHIP_TEMPERATURE, 8);
  response := SendRequest(request, 10);
  result := LEConvertInt16From(8, response);
end;

procedure TBrickletDMX.Reset;
var request: TByteArray;
begin
  CheckValidity;
  request := (ipcon as TIPConnection).CreateRequestPacket(self, BRICKLET_DMX_FUNCTION_RESET, 8);
  SendRequest(request, 0);
end;

procedure TBrickletDMX.WriteUID(const uid: longword);
var request: TByteArray;
begin
  CheckValidity;
  request := (ipcon as TIPConnection).CreateRequestPacket(self, BRICKLET_DMX_FUNCTION_WRITE_UID, 12);
  LEConvertUInt32To(uid, 8, request);
  SendRequest(request, 0);
end;

function TBrickletDMX.ReadUID: longword;
var request, response: TByteArray;
begin
  CheckValidity;
  request := (ipcon as TIPConnection).CreateRequestPacket(self, BRICKLET_DMX_FUNCTION_READ_UID, 8);
  response := SendRequest(request, 12);
  result := LEConvertUInt32From(8, response);
end;

procedure TBrickletDMX.GetIdentity(out uid: string; out connectedUid: string; out position: char; out hardwareVersion: TVersionNumber; out firmwareVersion: TVersionNumber; out deviceIdentifier: word);
var request, response: TByteArray; i: longint;
begin
  CheckValidity;
  request := (ipcon as TIPConnection).CreateRequestPacket(self, BRICKLET_DMX_FUNCTION_GET_IDENTITY, 8);
  response := SendRequest(request, 33);
  uid := LEConvertStringFrom(8, 8, response);
  connectedUid := LEConvertStringFrom(16, 8, response);
  position := LEConvertCharFrom(24, response);
  for i := 0 to 2 do hardwareVersion[i] := LEConvertUInt8From(25 + (i * 1), response);
  for i := 0 to 2 do firmwareVersion[i] := LEConvertUInt8From(28 + (i * 1), response);
  deviceIdentifier := LEConvertUInt16From(31, response);
end;

procedure TBrickletDMX.CallbackWrapperFrameStarted(const packet: TByteArray);
begin
  if (Length(packet) <> 8) then begin
    exit; { Silently ignoring callback with wrong length }
  end;
  if (Assigned(frameStartedCallback)) then begin
    frameStartedCallback(self);
  end;
end;

procedure TBrickletDMX.CallbackWrapperFrameAvailable(const packet: TByteArray);
var frameNumber: longword;
begin
  if (Length(packet) <> 12) then begin
    exit; { Silently ignoring callback with wrong length }
  end;
  frameNumber := LEConvertUInt32From(8, packet);
  if (Assigned(frameAvailableCallback)) then begin
    frameAvailableCallback(self, frameNumber);
  end;
end;

procedure TBrickletDMX.CallbackWrapperFrameLowLevel(const packet: TByteArray);
var frameLength: word; frameChunkOffset: word; frameChunkData: TArray0To55OfUInt8; frameNumber: longword; frameChunkLength: word; i: longint;
begin
  if (Length(packet) <> 72) then begin
    exit; { Silently ignoring callback with wrong length }
  end;
  frameLength := LEConvertUInt16From(8, packet);
  frameChunkOffset := LEConvertUInt16From(10, packet);
  for i := 0 to 55 do frameChunkData[i] := LEConvertUInt8From(12 + (i * 1), packet);
  frameNumber := LEConvertUInt32From(68, packet);

  frameChunkLength := frameLength - frameChunkOffset;
  if (frameChunkLength > 56) then begin
    frameChunkLength := 56;
  end;
  if (frameHighLevelCallbackState.data = nil) then begin { No stream in-progress }
    if (frameChunkOffset = 0) then begin { Stream starts }
      SetLength(frameHighLevelCallbackState.data, frameLength);
      Move(frameChunkData[0], frameHighLevelCallbackState.data[0], SizeOf(byte) * frameChunkLength);
      frameHighLevelCallbackState.length := frameChunkLength;

      if (frameHighLevelCallbackState.length >= frameLength) then begin { Stream complete }
        if (Assigned(frameCallback)) then begin
          frameCallback(self, frameHighLevelCallbackState.data, frameNumber);
        end;
        SetLength(frameHighLevelCallbackState.data, 0);
        frameHighLevelCallbackState.data := nil;
        frameHighLevelCallbackState.length := 0;
      end;
    end;
  end
  else begin { Stream in-progress }
    if (frameChunkOffset <> frameHighLevelCallbackState.length) then begin { Stream out-of-sync }
      SetLength(frameHighLevelCallbackState.data, 0);
      frameHighLevelCallbackState.data := nil;
      frameHighLevelCallbackState.length := 0;
      if (Assigned(frameCallback)) then begin
        frameCallback(self, frameHighLevelCallbackState.data, frameNumber);
      end;
    end
    else begin { Stream in-sync }
      Move(frameChunkData[0], frameHighLevelCallbackState.data[frameHighLevelCallbackState.length], SizeOf(byte) * frameChunkLength);
      Inc(frameHighLevelCallbackState.length, frameChunkLength);

      if frameHighLevelCallbackState.length >= frameLength then begin { Stream complete }
        if (Assigned(frameCallback)) then begin
          frameCallback(self, frameHighLevelCallbackState.data, frameNumber);
        end;
        SetLength(frameHighLevelCallbackState.data, 0);
        frameHighLevelCallbackState.data := nil;
        frameHighLevelCallbackState.length := 0;
      end;
    end;
  end;
  if (Assigned(frameLowLevelCallback)) then begin
    frameLowLevelCallback(self, frameLength, frameChunkOffset, frameChunkData, frameNumber);
  end;
end;

procedure TBrickletDMX.CallbackWrapperFrameErrorCount(const packet: TByteArray);
var overrunErrorCount: longword; framingErrorCount: longword;
begin
  if (Length(packet) <> 16) then begin
    exit; { Silently ignoring callback with wrong length }
  end;
  overrunErrorCount := LEConvertUInt32From(8, packet);
  framingErrorCount := LEConvertUInt32From(12, packet);
  if (Assigned(frameErrorCountCallback)) then begin
    frameErrorCountCallback(self, overrunErrorCount, framingErrorCount);
  end;
end;

end.
