{
  This file was automatically generated on 2020-05-19.

  Delphi/Lazarus Bindings Version 2.1.28

  If you have a bugfix for this file and want to commit it,
  please fix the bug in the generator. You can find a link
  to the generators git on tinkerforge.com
}

unit BrickletRS232V2;

{$ifdef FPC}{$mode OBJFPC}{$H+}{$endif}

interface

uses
  Device, IPConnection, LEConverter, Math, SyncObjs;

const
  BRICKLET_RS232_V2_DEVICE_IDENTIFIER = 2108;
  BRICKLET_RS232_V2_DEVICE_DISPLAY_NAME = 'RS232 Bricklet 2.0';

  BRICKLET_RS232_V2_FUNCTION_WRITE_LOW_LEVEL = 1;
  BRICKLET_RS232_V2_FUNCTION_READ_LOW_LEVEL = 2;
  BRICKLET_RS232_V2_FUNCTION_ENABLE_READ_CALLBACK = 3;
  BRICKLET_RS232_V2_FUNCTION_DISABLE_READ_CALLBACK = 4;
  BRICKLET_RS232_V2_FUNCTION_IS_READ_CALLBACK_ENABLED = 5;
  BRICKLET_RS232_V2_FUNCTION_SET_CONFIGURATION = 6;
  BRICKLET_RS232_V2_FUNCTION_GET_CONFIGURATION = 7;
  BRICKLET_RS232_V2_FUNCTION_SET_BUFFER_CONFIG = 8;
  BRICKLET_RS232_V2_FUNCTION_GET_BUFFER_CONFIG = 9;
  BRICKLET_RS232_V2_FUNCTION_GET_BUFFER_STATUS = 10;
  BRICKLET_RS232_V2_FUNCTION_GET_ERROR_COUNT = 11;
  BRICKLET_RS232_V2_FUNCTION_SET_FRAME_READABLE_CALLBACK_CONFIGURATION = 14;
  BRICKLET_RS232_V2_FUNCTION_GET_FRAME_READABLE_CALLBACK_CONFIGURATION = 15;
  BRICKLET_RS232_V2_FUNCTION_GET_SPITFP_ERROR_COUNT = 234;
  BRICKLET_RS232_V2_FUNCTION_SET_BOOTLOADER_MODE = 235;
  BRICKLET_RS232_V2_FUNCTION_GET_BOOTLOADER_MODE = 236;
  BRICKLET_RS232_V2_FUNCTION_SET_WRITE_FIRMWARE_POINTER = 237;
  BRICKLET_RS232_V2_FUNCTION_WRITE_FIRMWARE = 238;
  BRICKLET_RS232_V2_FUNCTION_SET_STATUS_LED_CONFIG = 239;
  BRICKLET_RS232_V2_FUNCTION_GET_STATUS_LED_CONFIG = 240;
  BRICKLET_RS232_V2_FUNCTION_GET_CHIP_TEMPERATURE = 242;
  BRICKLET_RS232_V2_FUNCTION_RESET = 243;
  BRICKLET_RS232_V2_FUNCTION_WRITE_UID = 248;
  BRICKLET_RS232_V2_FUNCTION_READ_UID = 249;
  BRICKLET_RS232_V2_FUNCTION_GET_IDENTITY = 255;

  BRICKLET_RS232_V2_CALLBACK_READ_LOW_LEVEL = 12;
  BRICKLET_RS232_V2_CALLBACK_ERROR_COUNT = 13;
  BRICKLET_RS232_V2_CALLBACK_FRAME_READABLE = 16;

  BRICKLET_RS232_V2_PARITY_NONE = 0;
  BRICKLET_RS232_V2_PARITY_ODD = 1;
  BRICKLET_RS232_V2_PARITY_EVEN = 2;
  BRICKLET_RS232_V2_STOPBITS_1 = 1;
  BRICKLET_RS232_V2_STOPBITS_2 = 2;
  BRICKLET_RS232_V2_WORDLENGTH_5 = 5;
  BRICKLET_RS232_V2_WORDLENGTH_6 = 6;
  BRICKLET_RS232_V2_WORDLENGTH_7 = 7;
  BRICKLET_RS232_V2_WORDLENGTH_8 = 8;
  BRICKLET_RS232_V2_FLOWCONTROL_OFF = 0;
  BRICKLET_RS232_V2_FLOWCONTROL_SOFTWARE = 1;
  BRICKLET_RS232_V2_FLOWCONTROL_HARDWARE = 2;
  BRICKLET_RS232_V2_BOOTLOADER_MODE_BOOTLOADER = 0;
  BRICKLET_RS232_V2_BOOTLOADER_MODE_FIRMWARE = 1;
  BRICKLET_RS232_V2_BOOTLOADER_MODE_BOOTLOADER_WAIT_FOR_REBOOT = 2;
  BRICKLET_RS232_V2_BOOTLOADER_MODE_FIRMWARE_WAIT_FOR_REBOOT = 3;
  BRICKLET_RS232_V2_BOOTLOADER_MODE_FIRMWARE_WAIT_FOR_ERASE_AND_REBOOT = 4;
  BRICKLET_RS232_V2_BOOTLOADER_STATUS_OK = 0;
  BRICKLET_RS232_V2_BOOTLOADER_STATUS_INVALID_MODE = 1;
  BRICKLET_RS232_V2_BOOTLOADER_STATUS_NO_CHANGE = 2;
  BRICKLET_RS232_V2_BOOTLOADER_STATUS_ENTRY_FUNCTION_NOT_PRESENT = 3;
  BRICKLET_RS232_V2_BOOTLOADER_STATUS_DEVICE_IDENTIFIER_INCORRECT = 4;
  BRICKLET_RS232_V2_BOOTLOADER_STATUS_CRC_MISMATCH = 5;
  BRICKLET_RS232_V2_STATUS_LED_CONFIG_OFF = 0;
  BRICKLET_RS232_V2_STATUS_LED_CONFIG_ON = 1;
  BRICKLET_RS232_V2_STATUS_LED_CONFIG_SHOW_HEARTBEAT = 2;
  BRICKLET_RS232_V2_STATUS_LED_CONFIG_SHOW_STATUS = 3;

type
  TArray0To2OfUInt8 = array [0..2] of byte;
  TArray0To59OfChar = array [0..59] of char;
  TArray0To63OfUInt8 = array [0..63] of byte;
  TArrayOfChar = array of char;

  TReadHighLevelCallbackState = record data: TArrayOfChar; length: word; end;

  TBrickletRS232V2 = class;
  TBrickletRS232V2NotifyReadLowLevel = procedure(sender: TBrickletRS232V2; const messageLength: word; const messageChunkOffset: word; const messageChunkData: TArray0To59OfChar) of object;
  TBrickletRS232V2NotifyRead = procedure(sender: TBrickletRS232V2; const message: TArrayOfChar) of object;
  TBrickletRS232V2NotifyErrorCount = procedure(sender: TBrickletRS232V2; const errorCountOverrun: longword; const errorCountParity: longword) of object;
  TBrickletRS232V2NotifyFrameReadable = procedure(sender: TBrickletRS232V2; const frameCount: word) of object;

  /// <summary>
  ///  Communicates with RS232 devices
  /// </summary>
  TBrickletRS232V2 = class(TDevice)
  private
    streamMutex: TCriticalSection;
    readHighLevelCallbackState: TReadHighLevelCallbackState;
    readLowLevelCallback: TBrickletRS232V2NotifyReadLowLevel;
    readCallback: TBrickletRS232V2NotifyRead;
    errorCountCallback: TBrickletRS232V2NotifyErrorCount;
    frameReadableCallback: TBrickletRS232V2NotifyFrameReadable;
  protected
    procedure CallbackWrapperReadLowLevel(const packet: TByteArray); virtual;
    procedure CallbackWrapperErrorCount(const packet: TByteArray); virtual;
    procedure CallbackWrapperFrameReadable(const packet: TByteArray); virtual;
  public
    /// <summary>
    ///  Creates an object with the unique device ID <c>uid</c>. This object can
    ///  then be added to the IP connection.
    /// </summary>
    constructor Create(const uid: string; ipcon_: TIPConnection);

    /// <summary>
    ///  Writes characters to the RS232 interface. The characters can be binary data,
    ///  ASCII or similar is not necessary.
    ///  
    ///  The return value is the number of characters that were written.
    ///  
    ///  See <see cref="BrickletRS232V2.TBrickletRS232V2.SetConfiguration"/> for configuration possibilities
    ///  regarding baud rate, parity and so on.
    /// </summary>
    function WriteLowLevel(const messageLength: word; const messageChunkOffset: word; const messageChunkData: TArray0To59OfChar): byte; virtual;

    /// <summary>
    ///  Writes characters to the RS232 interface. The characters can be binary data,
    ///  ASCII or similar is not necessary.
    ///  
    ///  The return value is the number of characters that were written.
    ///  
    ///  See <see cref="BrickletRS232V2.TBrickletRS232V2.SetConfiguration"/> for configuration possibilities
    ///  regarding baud rate, parity and so on.
    /// </summary>
    function Write(const message: array of char): word; virtual;

    /// <summary>
    ///  Returns up to *length* characters from receive buffer.
    ///  
    ///  Instead of polling with this function, you can also use
    ///  callbacks. But note that this function will return available
    ///  data only when the read callback is disabled.
    ///  See <see cref="BrickletRS232V2.TBrickletRS232V2.EnableReadCallback"/> and <see cref="BrickletRS232V2.TBrickletRS232V2.OnRead"/> callback.
    /// </summary>
    procedure ReadLowLevel(const length_: word; out messageLength: word; out messageChunkOffset: word; out messageChunkData: TArray0To59OfChar); virtual;

    /// <summary>
    ///  Returns up to *length* characters from receive buffer.
    ///  
    ///  Instead of polling with this function, you can also use
    ///  callbacks. But note that this function will return available
    ///  data only when the read callback is disabled.
    ///  See <see cref="BrickletRS232V2.TBrickletRS232V2.EnableReadCallback"/> and <see cref="BrickletRS232V2.TBrickletRS232V2.OnRead"/> callback.
    /// </summary>
    function Read(const length_: word): TArrayOfChar; virtual;

    /// <summary>
    ///  Enables the <see cref="BrickletRS232V2.TBrickletRS232V2.OnRead"/> callback. This will disable the <see cref="BrickletRS232V2.TBrickletRS232V2.OnFrameReadable"/> callback.
    ///  
    ///  By default the callback is disabled.
    /// </summary>
    procedure EnableReadCallback; virtual;

    /// <summary>
    ///  Disables the <see cref="BrickletRS232V2.TBrickletRS232V2.OnRead"/> callback.
    ///  
    ///  By default the callback is disabled.
    /// </summary>
    procedure DisableReadCallback; virtual;

    /// <summary>
    ///  Returns *true* if the <see cref="BrickletRS232V2.TBrickletRS232V2.OnRead"/> callback is enabled,
    ///  *false* otherwise.
    /// </summary>
    function IsReadCallbackEnabled: boolean; virtual;

    /// <summary>
    ///  Sets the configuration for the RS232 communication.
    /// </summary>
    procedure SetConfiguration(const baudrate: longword; const parity: byte; const stopbits: byte; const wordlength: byte; const flowcontrol: byte); virtual;

    /// <summary>
    ///  Returns the configuration as set by <see cref="BrickletRS232V2.TBrickletRS232V2.SetConfiguration"/>.
    /// </summary>
    procedure GetConfiguration(out baudrate: longword; out parity: byte; out stopbits: byte; out wordlength: byte; out flowcontrol: byte); virtual;

    /// <summary>
    ///  Sets the send and receive buffer size in byte. In total the buffers have to be
    ///  10240 byte (10KiB) in size, the minimum buffer size is 1024 byte (1KiB) for each.
    ///  
    ///  The current buffer content is lost if this function is called.
    ///  
    ///  The send buffer holds data that is given by <see cref="BrickletRS232V2.TBrickletRS232V2.Write"/> and
    ///  can not be written yet. The receive buffer holds data that is
    ///  received through RS232 but could not yet be send to the
    ///  user, either by <see cref="BrickletRS232V2.TBrickletRS232V2.Read"/> or through <see cref="BrickletRS232V2.TBrickletRS232V2.OnRead"/> callback.
    /// </summary>
    procedure SetBufferConfig(const sendBufferSize: word; const receiveBufferSize: word); virtual;

    /// <summary>
    ///  Returns the buffer configuration as set by <see cref="BrickletRS232V2.TBrickletRS232V2.SetBufferConfig"/>.
    /// </summary>
    procedure GetBufferConfig(out sendBufferSize: word; out receiveBufferSize: word); virtual;

    /// <summary>
    ///  Returns the currently used bytes for the send and received buffer.
    ///  
    ///  See <see cref="BrickletRS232V2.TBrickletRS232V2.SetBufferConfig"/> for buffer size configuration.
    /// </summary>
    procedure GetBufferStatus(out sendBufferUsed: word; out receiveBufferUsed: word); virtual;

    /// <summary>
    ///  Returns the current number of overrun and parity errors.
    /// </summary>
    procedure GetErrorCount(out errorCountOverrun: longword; out errorCountParity: longword); virtual;

    /// <summary>
    ///  Configures the <see cref="BrickletRS232V2.TBrickletRS232V2.OnFrameReadable"/> callback. The frame size is the number of bytes, that have to be readable to trigger the callback.
    ///  A frame size of 0 disables the callback. A frame size greater than 0 enables the callback and disables the <see cref="BrickletRS232V2.TBrickletRS232V2.OnRead"/> callback.
    ///  
    ///  By default the callback is disabled.
    ///  
    ///  .. versionadded:: 2.0.3$nbsp;(Plugin)
    /// </summary>
    procedure SetFrameReadableCallbackConfiguration(const frameSize: word); virtual;

    /// <summary>
    ///  Returns the callback configuration as set by <see cref="BrickletRS232V2.TBrickletRS232V2.SetFrameReadableCallbackConfiguration"/>.
    ///  
    ///  .. versionadded:: 2.0.3$nbsp;(Plugin)
    /// </summary>
    function GetFrameReadableCallbackConfiguration: word; virtual;

    /// <summary>
    ///  Returns the error count for the communication between Brick and Bricklet.
    ///  
    ///  The errors are divided into
    ///  
    ///  * ACK checksum errors,
    ///  * message checksum errors,
    ///  * framing errors and
    ///  * overflow errors.
    ///  
    ///  The errors counts are for errors that occur on the Bricklet side. All
    ///  Bricks have a similar function that returns the errors on the Brick side.
    /// </summary>
    procedure GetSPITFPErrorCount(out errorCountAckChecksum: longword; out errorCountMessageChecksum: longword; out errorCountFrame: longword; out errorCountOverflow: longword); virtual;

    /// <summary>
    ///  Sets the bootloader mode and returns the status after the requested
    ///  mode change was instigated.
    ///  
    ///  You can change from bootloader mode to firmware mode and vice versa. A change
    ///  from bootloader mode to firmware mode will only take place if the entry function,
    ///  device identifier and CRC are present and correct.
    ///  
    ///  This function is used by Brick Viewer during flashing. It should not be
    ///  necessary to call it in a normal user program.
    /// </summary>
    function SetBootloaderMode(const mode: byte): byte; virtual;

    /// <summary>
    ///  Returns the current bootloader mode, see <see cref="BrickletRS232V2.TBrickletRS232V2.SetBootloaderMode"/>.
    /// </summary>
    function GetBootloaderMode: byte; virtual;

    /// <summary>
    ///  Sets the firmware pointer for <see cref="BrickletRS232V2.TBrickletRS232V2.WriteFirmware"/>. The pointer has
    ///  to be increased by chunks of size 64. The data is written to flash
    ///  every 4 chunks (which equals to one page of size 256).
    ///  
    ///  This function is used by Brick Viewer during flashing. It should not be
    ///  necessary to call it in a normal user program.
    /// </summary>
    procedure SetWriteFirmwarePointer(const pointer: longword); virtual;

    /// <summary>
    ///  Writes 64 Bytes of firmware at the position as written by
    ///  <see cref="BrickletRS232V2.TBrickletRS232V2.SetWriteFirmwarePointer"/> before. The firmware is written
    ///  to flash every 4 chunks.
    ///  
    ///  You can only write firmware in bootloader mode.
    ///  
    ///  This function is used by Brick Viewer during flashing. It should not be
    ///  necessary to call it in a normal user program.
    /// </summary>
    function WriteFirmware(const data: array of byte): byte; virtual;

    /// <summary>
    ///  Sets the status LED configuration. By default the LED shows
    ///  communication traffic between Brick and Bricklet, it flickers once
    ///  for every 10 received data packets.
    ///  
    ///  You can also turn the LED permanently on/off or show a heartbeat.
    ///  
    ///  If the Bricklet is in bootloader mode, the LED is will show heartbeat by default.
    /// </summary>
    procedure SetStatusLEDConfig(const config: byte); virtual;

    /// <summary>
    ///  Returns the configuration as set by <see cref="BrickletRS232V2.TBrickletRS232V2.SetStatusLEDConfig"/>
    /// </summary>
    function GetStatusLEDConfig: byte; virtual;

    /// <summary>
    ///  Returns the temperature as measured inside the microcontroller. The
    ///  value returned is not the ambient temperature!
    ///  
    ///  The temperature is only proportional to the real temperature and it has bad
    ///  accuracy. Practically it is only useful as an indicator for
    ///  temperature changes.
    /// </summary>
    function GetChipTemperature: smallint; virtual;

    /// <summary>
    ///  Calling this function will reset the Bricklet. All configurations
    ///  will be lost.
    ///  
    ///  After a reset you have to create new device objects,
    ///  calling functions on the existing ones will result in
    ///  undefined behavior!
    /// </summary>
    procedure Reset; virtual;

    /// <summary>
    ///  Writes a new UID into flash. If you want to set a new UID
    ///  you have to decode the Base58 encoded UID string into an
    ///  integer first.
    ///  
    ///  We recommend that you use Brick Viewer to change the UID.
    /// </summary>
    procedure WriteUID(const uid: longword); virtual;

    /// <summary>
    ///  Returns the current UID as an integer. Encode as
    ///  Base58 to get the usual string version.
    /// </summary>
    function ReadUID: longword; virtual;

    /// <summary>
    ///  Returns the UID, the UID where the Bricklet is connected to,
    ///  the position, the hardware and firmware version as well as the
    ///  device identifier.
    ///  
    ///  The position can be 'a', 'b', 'c', 'd', 'e', 'f', 'g' or 'h' (Bricklet Port).
    ///  The Raspberry Pi HAT (Zero) Brick is always at position 'i' and the Bricklet
    ///  connected to an :ref:`Isolator Bricklet &lt;isolator_bricklet&gt;` is always as
    ///  position 'z'.
    ///  
    ///  The device identifier numbers can be found :ref:`here &lt;device_identifier&gt;`.
    ///  |device_identifier_constant|
    /// </summary>
    procedure GetIdentity(out uid: string; out connectedUid: string; out position: char; out hardwareVersion: TVersionNumber; out firmwareVersion: TVersionNumber; out deviceIdentifier: word); override;

    /// <summary>
    ///  <see cref="BrickletRS232V2.TBrickletRS232V2.OnRead"/>
    /// </summary>
    property OnReadLowLevel: TBrickletRS232V2NotifyReadLowLevel read readLowLevelCallback write readLowLevelCallback;

    /// <summary>
    ///  This callback is called if new data is available.
    ///  
    ///  To enable this callback, use <see cref="BrickletRS232V2.TBrickletRS232V2.EnableReadCallback"/>.
    ///  
    ///  <note>
    ///   If reconstructing the value fails, the callback is triggered with nil for message_.
    ///  </note>
    /// </summary>
    property OnRead: TBrickletRS232V2NotifyRead read readCallback write readCallback;

    /// <summary>
    ///  This callback is called if a new error occurs. It returns
    ///  the current overrun and parity error count.
    /// </summary>
    property OnErrorCount: TBrickletRS232V2NotifyErrorCount read errorCountCallback write errorCountCallback;

    /// <summary>
    ///  This callback is called if at least one frame of data is readable. The frame size is configured with <see cref="BrickletRS232V2.TBrickletRS232V2.SetFrameReadableCallbackConfiguration"/>.
    ///  The frame count parameter is the number of frames that can be read.
    ///  This callback is triggered only once until <see cref="BrickletRS232V2.TBrickletRS232V2.Read"/> is called. This means, that if you have configured a frame size of X bytes,
    ///  you can read exactly X bytes using the <see cref="BrickletRS232V2.TBrickletRS232V2.Read"/> function, every time the callback triggers without checking the frame count parameter.
    ///  
    ///  .. versionadded:: 2.0.3$nbsp;(Plugin)
    /// </summary>
    property OnFrameReadable: TBrickletRS232V2NotifyFrameReadable read frameReadableCallback write frameReadableCallback;
  end;

implementation

constructor TBrickletRS232V2.Create(const uid: string; ipcon_: TIPConnection);
begin
  inherited Create(uid, ipcon_, BRICKLET_RS232_V2_DEVICE_IDENTIFIER, BRICKLET_RS232_V2_DEVICE_DISPLAY_NAME);
  apiVersion[0] := 2;
  apiVersion[1] := 0;
  apiVersion[2] := 1;

  responseExpected[BRICKLET_RS232_V2_FUNCTION_WRITE_LOW_LEVEL] := DEVICE_RESPONSE_EXPECTED_ALWAYS_TRUE;
  responseExpected[BRICKLET_RS232_V2_FUNCTION_READ_LOW_LEVEL] := DEVICE_RESPONSE_EXPECTED_ALWAYS_TRUE;
  responseExpected[BRICKLET_RS232_V2_FUNCTION_ENABLE_READ_CALLBACK] := DEVICE_RESPONSE_EXPECTED_TRUE;
  responseExpected[BRICKLET_RS232_V2_FUNCTION_DISABLE_READ_CALLBACK] := DEVICE_RESPONSE_EXPECTED_TRUE;
  responseExpected[BRICKLET_RS232_V2_FUNCTION_IS_READ_CALLBACK_ENABLED] := DEVICE_RESPONSE_EXPECTED_ALWAYS_TRUE;
  responseExpected[BRICKLET_RS232_V2_FUNCTION_SET_CONFIGURATION] := DEVICE_RESPONSE_EXPECTED_FALSE;
  responseExpected[BRICKLET_RS232_V2_FUNCTION_GET_CONFIGURATION] := DEVICE_RESPONSE_EXPECTED_ALWAYS_TRUE;
  responseExpected[BRICKLET_RS232_V2_FUNCTION_SET_BUFFER_CONFIG] := DEVICE_RESPONSE_EXPECTED_FALSE;
  responseExpected[BRICKLET_RS232_V2_FUNCTION_GET_BUFFER_CONFIG] := DEVICE_RESPONSE_EXPECTED_ALWAYS_TRUE;
  responseExpected[BRICKLET_RS232_V2_FUNCTION_GET_BUFFER_STATUS] := DEVICE_RESPONSE_EXPECTED_ALWAYS_TRUE;
  responseExpected[BRICKLET_RS232_V2_FUNCTION_GET_ERROR_COUNT] := DEVICE_RESPONSE_EXPECTED_ALWAYS_TRUE;
  responseExpected[BRICKLET_RS232_V2_FUNCTION_SET_FRAME_READABLE_CALLBACK_CONFIGURATION] := DEVICE_RESPONSE_EXPECTED_TRUE;
  responseExpected[BRICKLET_RS232_V2_FUNCTION_GET_FRAME_READABLE_CALLBACK_CONFIGURATION] := DEVICE_RESPONSE_EXPECTED_ALWAYS_TRUE;
  responseExpected[BRICKLET_RS232_V2_FUNCTION_GET_SPITFP_ERROR_COUNT] := DEVICE_RESPONSE_EXPECTED_ALWAYS_TRUE;
  responseExpected[BRICKLET_RS232_V2_FUNCTION_SET_BOOTLOADER_MODE] := DEVICE_RESPONSE_EXPECTED_ALWAYS_TRUE;
  responseExpected[BRICKLET_RS232_V2_FUNCTION_GET_BOOTLOADER_MODE] := DEVICE_RESPONSE_EXPECTED_ALWAYS_TRUE;
  responseExpected[BRICKLET_RS232_V2_FUNCTION_SET_WRITE_FIRMWARE_POINTER] := DEVICE_RESPONSE_EXPECTED_FALSE;
  responseExpected[BRICKLET_RS232_V2_FUNCTION_WRITE_FIRMWARE] := DEVICE_RESPONSE_EXPECTED_ALWAYS_TRUE;
  responseExpected[BRICKLET_RS232_V2_FUNCTION_SET_STATUS_LED_CONFIG] := DEVICE_RESPONSE_EXPECTED_FALSE;
  responseExpected[BRICKLET_RS232_V2_FUNCTION_GET_STATUS_LED_CONFIG] := DEVICE_RESPONSE_EXPECTED_ALWAYS_TRUE;
  responseExpected[BRICKLET_RS232_V2_FUNCTION_GET_CHIP_TEMPERATURE] := DEVICE_RESPONSE_EXPECTED_ALWAYS_TRUE;
  responseExpected[BRICKLET_RS232_V2_FUNCTION_RESET] := DEVICE_RESPONSE_EXPECTED_FALSE;
  responseExpected[BRICKLET_RS232_V2_FUNCTION_WRITE_UID] := DEVICE_RESPONSE_EXPECTED_FALSE;
  responseExpected[BRICKLET_RS232_V2_FUNCTION_READ_UID] := DEVICE_RESPONSE_EXPECTED_ALWAYS_TRUE;
  responseExpected[BRICKLET_RS232_V2_FUNCTION_GET_IDENTITY] := DEVICE_RESPONSE_EXPECTED_ALWAYS_TRUE;

  streamMutex := TCriticalSection.Create;

  SetLength(readHighLevelCallbackState.data, 0);
  readHighLevelCallbackState.data := nil;
  readHighLevelCallbackState.length := 0;

  callbackWrappers[BRICKLET_RS232_V2_CALLBACK_READ_LOW_LEVEL] := {$ifdef FPC}@{$endif}CallbackWrapperReadLowLevel;
  callbackWrappers[BRICKLET_RS232_V2_CALLBACK_ERROR_COUNT] := {$ifdef FPC}@{$endif}CallbackWrapperErrorCount;
  callbackWrappers[BRICKLET_RS232_V2_CALLBACK_FRAME_READABLE] := {$ifdef FPC}@{$endif}CallbackWrapperFrameReadable;

  (ipcon as TIPConnection).AddDevice(self);
end;

function TBrickletRS232V2.WriteLowLevel(const messageLength: word; const messageChunkOffset: word; const messageChunkData: TArray0To59OfChar): byte;
var request, response: TByteArray; i: longint;
begin
  CheckValidity;
  request := (ipcon as TIPConnection).CreateRequestPacket(self, BRICKLET_RS232_V2_FUNCTION_WRITE_LOW_LEVEL, 72);
  LEConvertUInt16To(messageLength, 8, request);
  LEConvertUInt16To(messageChunkOffset, 10, request);
  for i := 0 to Length(messageChunkData) - 1 do LEConvertCharTo(messageChunkData[i], 12 + (i * 1), request);
  response := SendRequest(request, 9);
  result := LEConvertUInt8From(8, response);
end;

function TBrickletRS232V2.Write(const message: array of char): word;
var
  messageLength: word;
  messageChunkOffset: word;
  messageChunkLength: word;
  messageChunkData: TArray0To59OfChar;
  messageChunkWritten: byte;
begin
  if (Length(message) > 65535) then begin
    raise EInvalidParameterException.Create('Message can be at most 65535 items long');
  end;

  messageLength := Length(message);
  messageChunkOffset := 0;
  result := 0;

  if (messageLength = 0) then begin
    FillChar(messageChunkData[0], SizeOf(char) * 60, 0);
    result := WriteLowLevel(messageLength, messageChunkOffset, messageChunkData);
  end
  else begin
    streamMutex.Acquire;
    try
      while (messageChunkOffset < messageLength) do begin
        messageChunkLength := messageLength - messageChunkOffset;

        if (messageChunkLength > 60) then messageChunkLength := 60;

        FillChar(messageChunkData[0], SizeOf(char) * 60, 0);
        Move(message[messageChunkOffset], messageChunkData[0], SizeOf(char) * messageChunkLength);

        messageChunkWritten := WriteLowLevel(messageLength, messageChunkOffset, messageChunkData);
        Inc(result, messageChunkWritten);

        if (messageChunkWritten < 60) then break; { Either last chunk or short write }

        Inc(messageChunkOffset, 60);
      end;
    finally
      streamMutex.Release;
    end;
  end;
end;

procedure TBrickletRS232V2.ReadLowLevel(const length_: word; out messageLength: word; out messageChunkOffset: word; out messageChunkData: TArray0To59OfChar);
var request, response: TByteArray; i: longint;
begin
  CheckValidity;
  request := (ipcon as TIPConnection).CreateRequestPacket(self, BRICKLET_RS232_V2_FUNCTION_READ_LOW_LEVEL, 10);
  LEConvertUInt16To(length_, 8, request);
  response := SendRequest(request, 72);
  messageLength := LEConvertUInt16From(8, response);
  messageChunkOffset := LEConvertUInt16From(10, response);
  for i := 0 to 59 do messageChunkData[i] := LEConvertCharFrom(12 + (i * 1), response);
end;

function TBrickletRS232V2.Read(const length_: word): TArrayOfChar;
var
  message: TArrayOfChar;
  messageCurrentLength: word;
  messageLength: word;
  messageChunkOffset: word;
  messageChunkData: TArray0To59OfChar;
  messageOutOfSync: boolean;
  messageChunkLength: word;
begin
  SetLength(result, 0);
  SetLength(message, 0);
  streamMutex.Acquire;
  try
    messageLength := 0;
    ReadLowLevel(length_, messageLength, messageChunkOffset, messageChunkData);
    SetLength(message, messageLength);
    messageOutOfSync := (messageChunkOffset <> 0);

    if ((not messageOutOfSync) and (messageLength > 0)) then begin
      messageChunkLength := messageLength - messageChunkOffset;
      if (messageChunkLength > 60) then messageChunkLength := 60;
      Move(messageChunkData, message[0], SizeOf(char) * messageChunkLength);
      messageCurrentLength := messageChunkLength;

      while ((not messageOutOfSync) and (messageCurrentLength < messageLength)) do begin
        ReadLowLevel(length_, messageLength, messageChunkOffset, messageChunkData);
        messageOutOfSync := messageChunkOffset <> messageCurrentLength;
        messageChunkLength := messageLength - messageChunkOffset;
        if (messageChunkLength > 60) then messageChunkLength := 60;
        Move(messageChunkData, message[messageCurrentLength], SizeOf(char) * messageChunkLength);
        Inc(messageCurrentLength, messageChunkLength);
      end;
    end;

    if (messageOutOfSync) then begin
      { Discard remaining stream to bring it back in-sync }
      while (messageChunkOffset + 60 < messageLength) do begin
        ReadLowLevel(length_, messageLength, messageChunkOffset, messageChunkData);
      end;

      raise EStreamOutOfSyncException.Create('Message stream out-of-sync');
    end;
  finally
    streamMutex.Release;
  end;
  result := message;
end;

procedure TBrickletRS232V2.EnableReadCallback;
var request: TByteArray;
begin
  CheckValidity;
  request := (ipcon as TIPConnection).CreateRequestPacket(self, BRICKLET_RS232_V2_FUNCTION_ENABLE_READ_CALLBACK, 8);
  SendRequest(request, 0);
end;

procedure TBrickletRS232V2.DisableReadCallback;
var request: TByteArray;
begin
  CheckValidity;
  request := (ipcon as TIPConnection).CreateRequestPacket(self, BRICKLET_RS232_V2_FUNCTION_DISABLE_READ_CALLBACK, 8);
  SendRequest(request, 0);
end;

function TBrickletRS232V2.IsReadCallbackEnabled: boolean;
var request, response: TByteArray;
begin
  CheckValidity;
  request := (ipcon as TIPConnection).CreateRequestPacket(self, BRICKLET_RS232_V2_FUNCTION_IS_READ_CALLBACK_ENABLED, 8);
  response := SendRequest(request, 9);
  result := LEConvertBooleanFrom(8, response);
end;

procedure TBrickletRS232V2.SetConfiguration(const baudrate: longword; const parity: byte; const stopbits: byte; const wordlength: byte; const flowcontrol: byte);
var request: TByteArray;
begin
  CheckValidity;
  request := (ipcon as TIPConnection).CreateRequestPacket(self, BRICKLET_RS232_V2_FUNCTION_SET_CONFIGURATION, 16);
  LEConvertUInt32To(baudrate, 8, request);
  LEConvertUInt8To(parity, 12, request);
  LEConvertUInt8To(stopbits, 13, request);
  LEConvertUInt8To(wordlength, 14, request);
  LEConvertUInt8To(flowcontrol, 15, request);
  SendRequest(request, 0);
end;

procedure TBrickletRS232V2.GetConfiguration(out baudrate: longword; out parity: byte; out stopbits: byte; out wordlength: byte; out flowcontrol: byte);
var request, response: TByteArray;
begin
  CheckValidity;
  request := (ipcon as TIPConnection).CreateRequestPacket(self, BRICKLET_RS232_V2_FUNCTION_GET_CONFIGURATION, 8);
  response := SendRequest(request, 16);
  baudrate := LEConvertUInt32From(8, response);
  parity := LEConvertUInt8From(12, response);
  stopbits := LEConvertUInt8From(13, response);
  wordlength := LEConvertUInt8From(14, response);
  flowcontrol := LEConvertUInt8From(15, response);
end;

procedure TBrickletRS232V2.SetBufferConfig(const sendBufferSize: word; const receiveBufferSize: word);
var request: TByteArray;
begin
  CheckValidity;
  request := (ipcon as TIPConnection).CreateRequestPacket(self, BRICKLET_RS232_V2_FUNCTION_SET_BUFFER_CONFIG, 12);
  LEConvertUInt16To(sendBufferSize, 8, request);
  LEConvertUInt16To(receiveBufferSize, 10, request);
  SendRequest(request, 0);
end;

procedure TBrickletRS232V2.GetBufferConfig(out sendBufferSize: word; out receiveBufferSize: word);
var request, response: TByteArray;
begin
  CheckValidity;
  request := (ipcon as TIPConnection).CreateRequestPacket(self, BRICKLET_RS232_V2_FUNCTION_GET_BUFFER_CONFIG, 8);
  response := SendRequest(request, 12);
  sendBufferSize := LEConvertUInt16From(8, response);
  receiveBufferSize := LEConvertUInt16From(10, response);
end;

procedure TBrickletRS232V2.GetBufferStatus(out sendBufferUsed: word; out receiveBufferUsed: word);
var request, response: TByteArray;
begin
  CheckValidity;
  request := (ipcon as TIPConnection).CreateRequestPacket(self, BRICKLET_RS232_V2_FUNCTION_GET_BUFFER_STATUS, 8);
  response := SendRequest(request, 12);
  sendBufferUsed := LEConvertUInt16From(8, response);
  receiveBufferUsed := LEConvertUInt16From(10, response);
end;

procedure TBrickletRS232V2.GetErrorCount(out errorCountOverrun: longword; out errorCountParity: longword);
var request, response: TByteArray;
begin
  CheckValidity;
  request := (ipcon as TIPConnection).CreateRequestPacket(self, BRICKLET_RS232_V2_FUNCTION_GET_ERROR_COUNT, 8);
  response := SendRequest(request, 16);
  errorCountOverrun := LEConvertUInt32From(8, response);
  errorCountParity := LEConvertUInt32From(12, response);
end;

procedure TBrickletRS232V2.SetFrameReadableCallbackConfiguration(const frameSize: word);
var request: TByteArray;
begin
  CheckValidity;
  request := (ipcon as TIPConnection).CreateRequestPacket(self, BRICKLET_RS232_V2_FUNCTION_SET_FRAME_READABLE_CALLBACK_CONFIGURATION, 10);
  LEConvertUInt16To(frameSize, 8, request);
  SendRequest(request, 0);
end;

function TBrickletRS232V2.GetFrameReadableCallbackConfiguration: word;
var request, response: TByteArray;
begin
  CheckValidity;
  request := (ipcon as TIPConnection).CreateRequestPacket(self, BRICKLET_RS232_V2_FUNCTION_GET_FRAME_READABLE_CALLBACK_CONFIGURATION, 8);
  response := SendRequest(request, 10);
  result := LEConvertUInt16From(8, response);
end;

procedure TBrickletRS232V2.GetSPITFPErrorCount(out errorCountAckChecksum: longword; out errorCountMessageChecksum: longword; out errorCountFrame: longword; out errorCountOverflow: longword);
var request, response: TByteArray;
begin
  CheckValidity;
  request := (ipcon as TIPConnection).CreateRequestPacket(self, BRICKLET_RS232_V2_FUNCTION_GET_SPITFP_ERROR_COUNT, 8);
  response := SendRequest(request, 24);
  errorCountAckChecksum := LEConvertUInt32From(8, response);
  errorCountMessageChecksum := LEConvertUInt32From(12, response);
  errorCountFrame := LEConvertUInt32From(16, response);
  errorCountOverflow := LEConvertUInt32From(20, response);
end;

function TBrickletRS232V2.SetBootloaderMode(const mode: byte): byte;
var request, response: TByteArray;
begin
  CheckValidity;
  request := (ipcon as TIPConnection).CreateRequestPacket(self, BRICKLET_RS232_V2_FUNCTION_SET_BOOTLOADER_MODE, 9);
  LEConvertUInt8To(mode, 8, request);
  response := SendRequest(request, 9);
  result := LEConvertUInt8From(8, response);
end;

function TBrickletRS232V2.GetBootloaderMode: byte;
var request, response: TByteArray;
begin
  CheckValidity;
  request := (ipcon as TIPConnection).CreateRequestPacket(self, BRICKLET_RS232_V2_FUNCTION_GET_BOOTLOADER_MODE, 8);
  response := SendRequest(request, 9);
  result := LEConvertUInt8From(8, response);
end;

procedure TBrickletRS232V2.SetWriteFirmwarePointer(const pointer: longword);
var request: TByteArray;
begin
  CheckValidity;
  request := (ipcon as TIPConnection).CreateRequestPacket(self, BRICKLET_RS232_V2_FUNCTION_SET_WRITE_FIRMWARE_POINTER, 12);
  LEConvertUInt32To(pointer, 8, request);
  SendRequest(request, 0);
end;

function TBrickletRS232V2.WriteFirmware(const data: array of byte): byte;
var request, response: TByteArray; i: longint;
begin
  CheckValidity;
  request := (ipcon as TIPConnection).CreateRequestPacket(self, BRICKLET_RS232_V2_FUNCTION_WRITE_FIRMWARE, 72);
  if (Length(data) <> 64) then raise EInvalidParameterException.Create('Data has to be exactly 64 items long');
  for i := 0 to Length(data) - 1 do LEConvertUInt8To(data[i], 8 + (i * 1), request);
  response := SendRequest(request, 9);
  result := LEConvertUInt8From(8, response);
end;

procedure TBrickletRS232V2.SetStatusLEDConfig(const config: byte);
var request: TByteArray;
begin
  CheckValidity;
  request := (ipcon as TIPConnection).CreateRequestPacket(self, BRICKLET_RS232_V2_FUNCTION_SET_STATUS_LED_CONFIG, 9);
  LEConvertUInt8To(config, 8, request);
  SendRequest(request, 0);
end;

function TBrickletRS232V2.GetStatusLEDConfig: byte;
var request, response: TByteArray;
begin
  CheckValidity;
  request := (ipcon as TIPConnection).CreateRequestPacket(self, BRICKLET_RS232_V2_FUNCTION_GET_STATUS_LED_CONFIG, 8);
  response := SendRequest(request, 9);
  result := LEConvertUInt8From(8, response);
end;

function TBrickletRS232V2.GetChipTemperature: smallint;
var request, response: TByteArray;
begin
  CheckValidity;
  request := (ipcon as TIPConnection).CreateRequestPacket(self, BRICKLET_RS232_V2_FUNCTION_GET_CHIP_TEMPERATURE, 8);
  response := SendRequest(request, 10);
  result := LEConvertInt16From(8, response);
end;

procedure TBrickletRS232V2.Reset;
var request: TByteArray;
begin
  CheckValidity;
  request := (ipcon as TIPConnection).CreateRequestPacket(self, BRICKLET_RS232_V2_FUNCTION_RESET, 8);
  SendRequest(request, 0);
end;

procedure TBrickletRS232V2.WriteUID(const uid: longword);
var request: TByteArray;
begin
  CheckValidity;
  request := (ipcon as TIPConnection).CreateRequestPacket(self, BRICKLET_RS232_V2_FUNCTION_WRITE_UID, 12);
  LEConvertUInt32To(uid, 8, request);
  SendRequest(request, 0);
end;

function TBrickletRS232V2.ReadUID: longword;
var request, response: TByteArray;
begin
  CheckValidity;
  request := (ipcon as TIPConnection).CreateRequestPacket(self, BRICKLET_RS232_V2_FUNCTION_READ_UID, 8);
  response := SendRequest(request, 12);
  result := LEConvertUInt32From(8, response);
end;

procedure TBrickletRS232V2.GetIdentity(out uid: string; out connectedUid: string; out position: char; out hardwareVersion: TVersionNumber; out firmwareVersion: TVersionNumber; out deviceIdentifier: word);
var request, response: TByteArray; i: longint;
begin
  CheckValidity;
  request := (ipcon as TIPConnection).CreateRequestPacket(self, BRICKLET_RS232_V2_FUNCTION_GET_IDENTITY, 8);
  response := SendRequest(request, 33);
  uid := LEConvertStringFrom(8, 8, response);
  connectedUid := LEConvertStringFrom(16, 8, response);
  position := LEConvertCharFrom(24, response);
  for i := 0 to 2 do hardwareVersion[i] := LEConvertUInt8From(25 + (i * 1), response);
  for i := 0 to 2 do firmwareVersion[i] := LEConvertUInt8From(28 + (i * 1), response);
  deviceIdentifier := LEConvertUInt16From(31, response);
end;

procedure TBrickletRS232V2.CallbackWrapperReadLowLevel(const packet: TByteArray);
var messageLength: word; messageChunkOffset: word; messageChunkData: TArray0To59OfChar; messageChunkLength: word; i: longint;
begin
  if (Length(packet) <> 72) then begin
    exit; { Silently ignoring callback with wrong length }
  end;
  messageLength := LEConvertUInt16From(8, packet);
  messageChunkOffset := LEConvertUInt16From(10, packet);
  for i := 0 to 59 do messageChunkData[i] := LEConvertCharFrom(12 + (i * 1), packet);

  messageChunkLength := messageLength - messageChunkOffset;
  if (messageChunkLength > 60) then begin
    messageChunkLength := 60;
  end;
  if (readHighLevelCallbackState.data = nil) then begin { No stream in-progress }
    if (messageChunkOffset = 0) then begin { Stream starts }
      SetLength(readHighLevelCallbackState.data, messageLength);
      Move(messageChunkData[0], readHighLevelCallbackState.data[0], SizeOf(char) * messageChunkLength);
      readHighLevelCallbackState.length := messageChunkLength;

      if (readHighLevelCallbackState.length >= messageLength) then begin { Stream complete }
        if (Assigned(readCallback)) then begin
          readCallback(self, readHighLevelCallbackState.data);
        end;
        SetLength(readHighLevelCallbackState.data, 0);
        readHighLevelCallbackState.data := nil;
        readHighLevelCallbackState.length := 0;
      end;
    end;
  end
  else begin { Stream in-progress }
    if (messageChunkOffset <> readHighLevelCallbackState.length) then begin { Stream out-of-sync }
      SetLength(readHighLevelCallbackState.data, 0);
      readHighLevelCallbackState.data := nil;
      readHighLevelCallbackState.length := 0;
      if (Assigned(readCallback)) then begin
        readCallback(self, readHighLevelCallbackState.data);
      end;
    end
    else begin { Stream in-sync }
      Move(messageChunkData[0], readHighLevelCallbackState.data[readHighLevelCallbackState.length], SizeOf(char) * messageChunkLength);
      Inc(readHighLevelCallbackState.length, messageChunkLength);

      if readHighLevelCallbackState.length >= messageLength then begin { Stream complete }
        if (Assigned(readCallback)) then begin
          readCallback(self, readHighLevelCallbackState.data);
        end;
        SetLength(readHighLevelCallbackState.data, 0);
        readHighLevelCallbackState.data := nil;
        readHighLevelCallbackState.length := 0;
      end;
    end;
  end;
  if (Assigned(readLowLevelCallback)) then begin
    readLowLevelCallback(self, messageLength, messageChunkOffset, messageChunkData);
  end;
end;

procedure TBrickletRS232V2.CallbackWrapperErrorCount(const packet: TByteArray);
var errorCountOverrun: longword; errorCountParity: longword;
begin
  if (Length(packet) <> 16) then begin
    exit; { Silently ignoring callback with wrong length }
  end;
  errorCountOverrun := LEConvertUInt32From(8, packet);
  errorCountParity := LEConvertUInt32From(12, packet);
  if (Assigned(errorCountCallback)) then begin
    errorCountCallback(self, errorCountOverrun, errorCountParity);
  end;
end;

procedure TBrickletRS232V2.CallbackWrapperFrameReadable(const packet: TByteArray);
var frameCount: word;
begin
  if (Length(packet) <> 10) then begin
    exit; { Silently ignoring callback with wrong length }
  end;
  frameCount := LEConvertUInt16From(8, packet);
  if (Assigned(frameReadableCallback)) then begin
    frameReadableCallback(self, frameCount);
  end;
end;

end.
